/*******************************************************************************
* Copyright (C) 2003 by LSI Logic Corporation.  
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the
* Free Software Foundation,  version 2 of the License.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
********************************************************************************/
/*******************************************************************************

NAME            MPP_hba.c
SUMMARY         %description%
VERSION         %version: 58.1.1 %
UPDATE DATE     %date_modified: Wed Mar 10 16:20:02 2004 %
PROGRAMMER      %created_by:    yqi %

        Copyright 2000 by LSI Logic Inc.

DESCRIPTION:

INCLUDE FILES:

NOTES:

RESTRICTIONS:

SEE ALSO:

REFERENCE:

IMPLEMENTATION:

MODIFICATION HISTORY:

*******************************************************************************/
/*
*	For Error Log purposes this module has been assigned numbers 1-249.  
*	the last number currently used is 120.
*/
#define __SRCMPP_hba

/***  INCLUDES  ***/  

#include "MPP_Sysdep.h"
#include "MPP_Common.h"
#include "MPP_RdacInfo.h"
#include "MPP_ProtoTypes.h"
#include "mppCmn_s2tos3.h"
#include "copyright.h"

/***  CONSTANT DEFINITIONS  ***/
TEXT mpp_VendorId[9] = "        \0";
TEXT mpp_ProductId[17] = "                \0";
TEXT mpp_Version[12] = RAID_MANAGER_VERSION;
 
LWORD mpp_Debug = 0;
LWORD mpp_NotReadyWaitTime = 300;
LWORD mpp_BusyWaitTime = 300;
LWORD mpp_QuiescenceWaitTime = 300;
LWORD mpp_InquiryWaitTime = 60;
LWORD mpp_MaxLunsPerArray = 32;
LWORD mpp_MaxPathsPerController = 1;
LWORD mpp_ScanInterval = 60;
LWORD mpp_InquiryInterval = 1;
LWORD mpp_MaxArrayModules = 30;
LWORD mpp_ErrorLevel = 3;
LWORD mpp_SelectionTimeoutRetryCount = 0;
LWORD mpp_CommandTimeoutRetryCount = 1;
LWORD mpp_UaRetryCount = 10;
LWORD mpp_SyncRetryCount = 4;
LWORD mpp_SynchTimeout=10;  /* synchronous I/O timeout in seconds */
LWORD mpp_FailOverQuiescenceTime = 20;
LWORD mpp_FailoverTimeout = 120;
LWORD mpp_FailBackToCurrentAllowed = 1; 
LWORD mpp_HoldAltInReset = 0;
LWORD mpp_DoUARetry = 0;
int   mpp_FailBackInProgress = 0;
LWORD mpp_ControllerIoWaitTime = 120;
LWORD mpp_ArrayIoWaitTime = 240;
LWORD mpp_DisableLUNRebalance = 0;
BYTE  mpp_S2ToS3Key[8];

ArrayModuleEntry_t *mpp_ModuleArray;


BYTE mpp_HardwareStamp[4]={0x68, 0x77, 0x72, 0x34};
BYTE mpp_FirmwareStamp[4]={0x66, 0x77, 0x72, 0x34};	
BYTE mpp_SoftwareStamp[4]={0x73, 0x77, 0x72, 0x34};

MPP_FEATURE_SUPPORT	mpp_FeatureSupport[] =
{
	{ FeatMinimumFirmwareRelease, MINIMUM_MAJOR_REL, MINIMUM_MINOR_REL, 0 }
};

#define	MAX_FEATURE_SUPPORT	sizeof(mpp_FeatureSupport)/sizeof(MPP_FEATURE_SUPPORT)



/***  MACRO DEFINITIONS  ***/


/***  TYPE DEFINITIONS  ***/


/***  LOCALS  ***/
LWORD mpp_GetAVTData(MPP_HANDLE DeviceVertex, BYTE *AVTPriority, BOOL *CurrentOwner, BOOL *AVTEnabled);
LWORD mpp_GetMaxLunsSupported(MPP_HANDLE DeviceVertex, BYTE *MaxLuns);
LWORD mpp_CheckSwVersion(MPP_HANDLE DeviceVertex, BYTE *);
VOID mpp_CheckForMultiplePaths(void );
BYTE mpp_FailController(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Lun);
LWORD mpp_SynchronousIo(MPP_HANDLE DeviceVertex, BYTE *cdb, BYTE cdblen, void *BufferAddress, LWORD BufferLength, TINY Direction);
LWORD mpp_IsNull(BYTE *BufferAddress, LWORD BufferLength);
LWORD mpp_IsBlank(BYTE *BufferAddress, LWORD BufferLength);
VOID mpp_ConvertWWNtoAscii(BYTE *AsciiWWN, BYTE *ArrayWWN);
void mpp_CreatePage2CSubPageFailoverCommand(ModePage2CSubPage_t *page2C, BYTE *cdb);
void mpp_CreatePage2CFailoverCommand(ModePage2C_t *page2C, BYTE *cdb);
BOOL mpp_CreatePage2CSubPageRebalance(ModePage2CSubPage_t *page2C, BYTE *cdb, int Controller, 
	RdacLunInformation_t RdacLuns[]);
BOOL mpp_CreatePage2CRebalance(ModePage2C_t *page2C, BYTE *cdb, int Controller, 
	RdacLunInformation_t RdacLuns[]);
BOOL
mppCmn_IsConfiguredDevice(MPP_HANDLE DeviceVertex, ControllerAddress_t *DeviceAddress, LWORD Lun);
/***  PROCEDURES  ***/

/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_FailBackScan
* SUMMARY:  go thru  the RDAC array looking for failed controllers and
*       	check to see if their back online
*/
void 
mpp_FailBackScan(void)
{
	RdacDeviceInformation_t *RdacInfo;
	MPP_HANDLE 			DeviceObject;
	BYTE 				Controller;
	BYTE				path;
	LWORD				Lun;
	BYTE				i;
	ArrayModuleEntry_t		*ModPtr;
	BYTE 				PathAvail = 0;
	VOID				*Page2C;
	BYTE				*cdb;
	int				PageSize;
	BOOL				AvtChecked = FALSE;
	BOOL				MoveLuns;
	LWORD				*AlreadyIssuedInquiry;
	LWORD				CheckReservationStatus;

	/* need to initialize to false value */
	AlreadyIssuedInquiry = (LWORD *) MPP_INT_KMEM_ALLOC(sizeof(LWORD) * mpp_MaxArrayModules);
	if(!AlreadyIssuedInquiry)
	{
		MPP_DEBUGPRINT((MPP_FAILOVERSCAN_DEBUG+MPP_DEBUG_LEVEL_1,
			"Mpp_FailBackScan: Could not alloc inquiry memory\n"));
		return;
	}

	bzero(AlreadyIssuedInquiry, sizeof(LWORD) * mpp_MaxArrayModules);
	MPP_DEBUGPRINT((MPP_FAILOVERSCAN_DEBUG+MPP_DEBUG_LEVEL_4,
		"Mpp_FailBackScan: Called\n"));

	mpp_FailBackInProgress = TRUE;
	
	ModPtr = mpp_ModuleArray;
	for(i=0, MoveLuns = FALSE; i<mpp_MaxArrayModules; ++i, ++ModPtr, MoveLuns = FALSE) 
	{
		RdacInfo = ModPtr->RdacInfo;
		if( !RdacInfo )
			continue;
		for( Controller=0; Controller<2; ++Controller ) 
		{
			if( !RdacInfo->ControllerInfo[Controller]->ControllerPresent ) 
					continue;
			for( path=0; path<mpp_MaxPathsPerController; ++path ) 
			{
				DeviceObject = NULL;
				if( ! RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Present )
				{
					continue;
				}
				if ( ! RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Failed ) {
					for( Lun=0; Lun<mpp_MaxLunsPerArray; ++Lun ) {
						if( !RdacInfo->RdacLuns[Lun].Present ||
						!RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].LunPathDevice ||
						RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].PathRemoveState ) 
						{
							continue;
						}
						DeviceObject = RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].LunPathDevice;
						/* If we have already not issued a successful INQUIRY to this array */
						if ( ! AlreadyIssuedInquiry[i] )
							if( mpp_CheckSwVersion(DeviceObject, &RdacInfo->FirmwareVersion[0] ) )
							{
								MPP_DEBUGPRINT((MPP_FAILOVERSCAN_DEBUG+MPP_DEBUG_LEVEL_1,
								"Mpp_FailBackScan: Getting Array Firmware Version %s:%d:%d\n",
								RdacInfo->ModuleName, Controller, path));
								if(((RdacInfo->FirmwareVersion[0] & 0x0f) == 0x05) && ((RdacInfo->FirmwareVersion[1] & 0x0f0 ) >= 0x40))
									RdacInfo->FWSonoran4OrLater = TRUE;
								if((RdacInfo->FirmwareVersion[0] & 0x0f) > 0x05) 
									RdacInfo->FWSonoran4OrLater = TRUE;
								AlreadyIssuedInquiry[i] = TRUE;
							}
					}
				}
	
				if ( RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Failed ) {
					for( Lun=0; Lun<mpp_MaxLunsPerArray; ++Lun ) 
					{
						if( !RdacInfo->RdacLuns[Lun].Present ||
						!RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].LunPathDevice ||
						RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].PathRemoveState ) 
						{
							continue;
						}
						DeviceObject = RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].LunPathDevice;
						MPP_DEBUGPRINT((MPP_FAILOVERSCAN_DEBUG+MPP_DEBUG_LEVEL_1,
						"Mpp_FailBackScan: Checking Failed Device %s:%d:%d\n",
						RdacInfo->ModuleName, Controller, path));

						if( mpp_CheckSwVersion(DeviceObject, &RdacInfo->FirmwareVersion[0] ) )
						{
                     /*
                     * check whether of not we need to make a persistent reservation registration
                     * for the unfailed path.
                     * we must go through all LUNs
                     */
							CheckReservationStatus = mppCmn_CheckPRRegistration(RdacInfo, DeviceObject);
                     if(CheckReservationStatus == MPPCMN_PRTN_RETURN_ERROR)
                     {
                        MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 118,
						         "Mpp_FailBackScan: Device %s:%d:%d - get error in checking PR registration\n",
						         RdacInfo->ModuleName, Controller, path));
                     }
                     else
                     {
                        MPP_DEBUGPRINT((MPP_FAILOVERSCAN_DEBUG+MPP_DEBUG_LEVEL_1,
						         "Mpp_FailBackScan: Device %s:%d:%d - Checked PR registrationd\n",
						         RdacInfo->ModuleName, Controller, path));
                     }

							++PathAvail;
							RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Failed = FALSE;
							if(RdacInfo->ControllerInfo[Controller]->Failed)
								RdacInfo->ControllerInfo[Controller]->Failed = FALSE;
							ModPtr->ControllerRestored = TRUE;
						} 
						else
						{
                     /* PathAvail is initilaized to 0
                     */
							//PathAvail = 0;
						}
					}

					if(PathAvail)
					{
						MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 1,
						"%s:%d:%d - Unfailed\n",
						RdacInfo->ModuleName, Controller, path));
						if(!RdacInfo->ControllerInfo[Controller]->Failed)
						{
							MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 2,
							"%s:%d - Unfailed\n",
							RdacInfo->ModuleName, Controller));
						}
					}
					else
					{
						MPP_DEBUGPRINT((MPP_FAILOVERSCAN_DEBUG+MPP_DEBUG_LEVEL_1,
						"Mpp_FailBackScan: Device %s:%d:%d - Still Failed failed\n",
						RdacInfo->ModuleName, Controller, path));

						MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 114,
						"Mpp_FailBackScan: Device %s:%d:%d - Still Failed\n",
						RdacInfo->ModuleName, Controller, path));
					}
				}
			}
		}

	   	/*
	   	 * If AVT is not enabled, make a check for all LUN's preferred paths.
	   	 * Then put back LUN's to their preferred paths if the DisableLUNRebalance flag is not true.
	   	 */
		for( Controller=0; Controller<2; ++Controller ) 
		{
			if (ModPtr->ControllerRestored && ! mpp_DisableLUNRebalance && ! RdacInfo->AVTEnabled &&
				!RdacInfo->ControllerInfo[Controller]->FailoverInProgress &&
				RdacInfo->ControllerInfo[Controller]->ControllerPresent)
			{
				/* make inquiries to refresh LUNs' preferred paths */
				if (! AvtChecked )
				{
					/* only need to perform this check once, it covers all SA's connected to host */
					mpp_CheckPreferredAVTOwner( FALSE );
					AvtChecked = TRUE;
				}

				if(RdacInfo->Page2CSubPage1)
				{
					Page2C = (ModePage2CSubPage_t *) MPP_INT_KMEM_ALLOC(sizeof(ModePage2CSubPage_t)+10);
					PageSize = sizeof(ModePage2CSubPage_t);
				}
				else
				{
					Page2C = (ModePage2C_t *) MPP_INT_KMEM_ALLOC(sizeof(ModePage2C_t)+10);
					PageSize = sizeof(ModePage2C_t);
				}

				if(!Page2C) 
				{
					MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 8, 
						"%s FailBackScan could not alloc memory to rebalance LUNs\n", RdacInfo->ModuleName));
					return;
				}

				if(RdacInfo->Page2CSubPage1)
				{
					cdb = ((BYTE *) Page2C) + sizeof(ModePage2CSubPage_t);
					MoveLuns = mpp_CreatePage2CSubPageRebalance(Page2C, cdb, Controller, RdacInfo->RdacLuns);
				}
				else
				{
					cdb = ((BYTE *) Page2C) + sizeof(ModePage2C_t);
					MoveLuns = mpp_CreatePage2CRebalance(Page2C, cdb, Controller, RdacInfo->RdacLuns);
				}
	    	
				DeviceObject = NULL;
				if (MoveLuns)
				{
					/* send the command to first available LUN */
					for( path=0; path<mpp_MaxPathsPerController && ! DeviceObject; ++path ) 
					{
						if( !RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Present || 
						    RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Failed ) 
			    			{
							continue;
						}

						for( Lun=0; Lun<mpp_MaxLunsPerArray; ++Lun ) 
						{
							if( !RdacInfo->RdacLuns[Lun].Present ||
							    !RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].LunPathDevice ||
							    RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].PathRemoveState) 
							{
								continue;
							}
							else
							{
								DeviceObject = RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].LunPathDevice;
								break;
							}
						}
					}
	
					if (DeviceObject != NULL)
					{
						/* send the rebalance mode select to controller */
						if (mpp_SynchronousIo(DeviceObject, cdb, 10, Page2C, PageSize, 0) != MPP_NO_ERROR)
						{
							/* command failed */
							MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 115,
								"Mpp_FailBackScan: Device %s:%d - Unable to rebalance LUNs\n",
								RdacInfo->ModuleName, Controller));
						}
						else
						{
							/* command succeeded, reset SA level flag */
							ModPtr->ControllerRestored = FALSE;
							MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 116,
								"Mpp_FailBackScan: Device %s:%d - Rebalanced LUNs\n",
								RdacInfo->ModuleName, Controller));
						}
					}
					else
					{
						/* could not find a valid device to send mode select to */
						/* 08/19/03 - Changed the error level from FATAL to RECOVERED to reduce the
						 * number of error messages produced */
						MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 117,
							"Mpp_FailBackScan: Device %s:%d - Unable to find valid path or LUN to send rebalance command to\n",
							RdacInfo->ModuleName, Controller));
					}
				}
			
				/* free memory for command */
				if (Page2C)
				{
					MPP_FREE(Page2C, PageSize + 10);
				}
			}
		}
   }

   MPP_FREE(AlreadyIssuedInquiry, sizeof(LWORD) * mpp_MaxArrayModules);	
	mpp_FailBackInProgress = FALSE;

	// 09/26/02 - Added function to print an error message if only one path to a given Lun exists.
	mpp_CheckForMultiplePaths();
   
}

/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_CheckAVTState
* SUMMARY:  go thru  the RDAC array looking for a physical path to the array
*       	check its AVT state; enabled/disabled
*/
void 
mpp_CheckAVTState(void)
{
    	RdacDeviceInformation_t *RdacInfo;
    	MPP_HANDLE DeviceObject;
    	BYTE Controller, path, i, AVTPriority, ModuleDone;
	LWORD Lun;
	BOOL CurrentOwner, AVTEnabled;
	ArrayModuleEntry_t *ModPtr;

	MPP_DEBUGPRINT((MPP_AVTSCAN_DEBUG+MPP_DEBUG_LEVEL_4,
		"Mpp_CheckAVTState: Called\n"));

	ModPtr = mpp_ModuleArray;
	for(i=0; i<mpp_MaxArrayModules; ++i, ++ModPtr) {
		RdacInfo = ModPtr->RdacInfo;
		if( !RdacInfo )
			continue;
		ModuleDone = 0;
    		for( Controller=0; Controller<2; ++Controller ) {
		        if( !RdacInfo->ControllerInfo[Controller]->ControllerPresent || 
		    	    RdacInfo->ControllerInfo[Controller]->Failed ) 
			    	continue;	
			for( path=0; path<mpp_MaxPathsPerController; ++path ) {
				DeviceObject = NULL;
				if( !RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Present || 
			    	    RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Failed ) 
				    	continue;
				for( Lun=0; Lun<mpp_MaxLunsPerArray; ++Lun ) {
					if( !RdacInfo->RdacLuns[Lun].Present ||
					    !RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].LunPathDevice ||
					    RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].PathRemoveState ) 
						continue;
					DeviceObject = RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].LunPathDevice;
					MPP_DEBUGPRINT((MPP_AVTSCAN_DEBUG+MPP_DEBUG_LEVEL_3,
						"mpp_CheckAVTState: Checking Device %s:%d:%d:%d - 0x%lx\n",
						RdacInfo->ModuleName, Controller, path, Lun, DeviceObject));
					if( mpp_GetAVTData(DeviceObject, &AVTPriority,&CurrentOwner, &AVTEnabled) ) {
						MPP_DEBUGPRINT((MPP_AVTSCAN_DEBUG+MPP_DEBUG_LEVEL_3,
							"mpp_CheckAVTState: AVTPriority 0x%x, CurrentOwner %d, AVTEnabled %d\n",
							AVTPriority, CurrentOwner, AVTEnabled));
						if( RdacInfo->AVTEnabled != (LWORD) AVTEnabled  )
							MPP_ERRORLOGPRINT((MPP_ERR_CTLR_FAILOVER, 3,
							"%s - AVT Toggled - %d\n",
							RdacInfo->ModuleName, AVTEnabled));
							RdacInfo->AVTEnabled = AVTEnabled;
							ModuleDone = 1;
							break;
					} else {
						MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 4,
							"Error accessing %s:%d:%d:%d for AVT state check\n",
							RdacInfo->ModuleName, Controller, path, Lun));
					}
				}
				if( ModuleDone )
					break;
			}
			if( ModuleDone )
				break;
		}
	}
}

/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_CheckPreferredAVTOwner
* SUMMARY:  go thru  the RDAC array looking for a physical path to each array Lun
*       	check its AVT Preferred owner
*/
void 
mpp_CheckPreferredAVTOwner( BOOL checkAVTEnabled)
{
	RdacDeviceInformation_t *RdacInfo;
	MPP_HANDLE DeviceObject;
	BYTE Controller, path, i, AVTPriority, PreferredOwner, LunDone;
	LWORD Lun;
	BOOL CurrentOwner, AVTEnabled;
	ArrayModuleEntry_t *ModPtr;

    	
	MPP_DEBUGPRINT((MPP_AVTSCAN_DEBUG+MPP_DEBUG_LEVEL_4,
		"mpp_CheckPreferredAVTOwner: Called\n"));

	ModPtr = mpp_ModuleArray;
	for(i=0; i<mpp_MaxArrayModules; ++i, ++ModPtr) {
		if( !(RdacInfo = ModPtr->RdacInfo) || (!RdacInfo->AVTEnabled && checkAVTEnabled) ) 
		{
			continue;
		}
		MPP_DEBUGPRINT((MPP_AVTSCAN_DEBUG+MPP_DEBUG_LEVEL_3,
		"mpp_CheckPreferredAVTOwner: Checking Virtual Target %d, RdacInfo 0x%lx\n", i, RdacInfo));
		for( Lun=0; Lun<mpp_MaxLunsPerArray; ++Lun ) {
			LunDone = 0;
			if( !RdacInfo->RdacLuns[Lun].Present || RdacInfo->RdacLuns[Lun].UTMLun )
				continue;
    			for( Controller=0; Controller<2; ++Controller ) 
    			{
					if( !RdacInfo->ControllerInfo[Controller]->ControllerPresent || 
	       	    		RdacInfo->ControllerInfo[Controller]->Failed ) 
	       	    	{
						continue;
					}
	       			for( path=0; path<mpp_MaxPathsPerController; ++path ) {
	       				DeviceObject = NULL;
	       				if( !RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Present || 
	       		    	    	    RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Failed || 
					    !RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].LunPathDevice ||
					    RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].PathRemoveState ) 
					{
						continue;
					}
					
					DeviceObject = RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[path].LunPathDevice;
					MPP_DEBUGPRINT((MPP_AVTSCAN_DEBUG+MPP_DEBUG_LEVEL_3,
						"mpp_CheckPreferredAVTOwner: Checking Device %s:%d:%d:%d - 0x%lx\n",
						RdacInfo->ModuleName, Controller, path, Lun, DeviceObject));
					if( mpp_GetAVTData(DeviceObject, &AVTPriority, &CurrentOwner, &AVTEnabled) ) 
					{
						MPP_DEBUGPRINT((MPP_AVTSCAN_DEBUG+MPP_DEBUG_LEVEL_3,
						"mpp_CheckPreferredAVTOwner: AVTPriority 0x%x, CurrentOwner %d, AVTEnabled %d\n",
						AVTPriority, CurrentOwner, AVTEnabled));
						
						if( AVTPriority == 1 )
							PreferredOwner = Controller;
						else
							PreferredOwner = Controller ^ 1;
						if( (RdacInfo->ControllerInfo[PreferredOwner]->ControllerPresent) &&
					    	    (!RdacInfo->ControllerInfo[PreferredOwner]->Failed) &&
					    	    ((RdacInfo->RdacLuns[Lun].CurrentOwningPath != PreferredOwner) ||
					    	    (RdacInfo->RdacLuns[Lun].PreferredPath != PreferredOwner)) ) 
						{
							MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 5,
								"%s:%d Preferred Owner set - %d\n",
								RdacInfo->ModuleName, Lun, PreferredOwner));
							if(RdacInfo->AVTEnabled)
								RdacInfo->RdacLuns[Lun].CurrentOwningPath = PreferredOwner;
							RdacInfo->RdacLuns[Lun].PreferredPath = PreferredOwner;
						}
						
						LunDone = 1;
						break;
					} 
					else 
					{
						MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 6,
							"Error accessing %s:%d:%d:%d to check AVT owner\n",
							RdacInfo->ModuleName, Controller, path, Lun));
					}
				}
				
				if( LunDone )
					break;
			}
			
		}
	}
}


/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_CheckForMultiplePaths
* SUMMARY:  Verify whether each Lun has more than one path and print an
*           error message if only one path is found.
*
*/
VOID mpp_CheckForMultiplePaths(void)
{
	RdacDeviceInformation_t	*rdacInfo;
	LWORD			count, lun, controller, path, lunPathCnt = 0;
	ArrayModuleEntry_t 	*moduleArray;

	for(count=0; count<mpp_MaxArrayModules; ++count)
	{
		moduleArray = mpp_ModuleArray + count;
		if((rdacInfo = moduleArray->RdacInfo))
		{
			for(lun=0; lun<mpp_MaxLunsPerArray; ++lun)
			{
				if(!(rdacInfo->RdacLuns[lun].PseudoLunObject &&
				   !rdacInfo->RdacLuns[lun].NotConfigured &&
				   rdacInfo->RdacLuns[lun].PseudoDevState != Deleted &&
				   rdacInfo->RdacLuns[lun].ReportedPresent))
					continue;

				for(controller = 0; controller < 2; ++controller)
				{
					for(path = 0; path < mpp_MaxPathsPerController; ++path)
					{
						if(rdacInfo->ControllerInfo[controller]->ControllerPresent &&
						   rdacInfo->ControllerInfo[controller]->ControllerPath[path].Present &&
						   rdacInfo->RdacLuns[lun].LunControllers[controller]->LunPaths[path].PathStartState == MPP_STARTED)
						{
							lunPathCnt++;
						}
					
					}
				}

				if(lunPathCnt <= 1)
				{
					MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 107, "Lun %s:%d has a single path\n",
						rdacInfo->ModuleName, lun));
				}

				lunPathCnt = 0;
			}
		}
	}
}


/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_VirtualdiskInquiryData
* SUMMARY:  Insert the MPP driver inquiry data
*
*/
void
mpp_VirtualdiskInquiryData(TEXT *inqData)
{
    bcopy((caddr_t) mpp_VendorId, (caddr_t) (inqData + 8), 8);
    bcopy((caddr_t) mpp_ProductId, (caddr_t) (inqData + 16), 16);
}

/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_FailPath
* SUMMARY:  Fail the given Controller/Path and Determine if there is another path to this controller
*/
BYTE 
mpp_FailPath(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path)
{
	LINT LockLevel;
	BYTE i, FailedPath=0, AnotherPathAvailable=0;
	LWORD j;

	MPP_LOCK(RdacInfo->Lock, LockLevel);
	if( !RdacInfo->ControllerInfo[Controller]->ControllerPath[Path].Failed ) {

	      	RdacInfo->ControllerInfo[Controller]->ControllerPath[Path].Failed = TRUE;
		FailedPath = 1;
	}
	for(i=0; i<mpp_MaxPathsPerController; ++i) {
		if( !RdacInfo->ControllerInfo[Controller]->ControllerPath[i].Failed ) {
			for(j=0; j<mpp_MaxLunsPerArray; ++j) {
				if( RdacInfo->RdacLuns[j].LunControllers[Controller]->LunPaths[i].LunPathDevice &&
		    		    mpp_CheckPathGood(RdacInfo, Controller, i, j) ) {
					MPP_DEBUGPRINT((MPP_FAILOVER_IO_DEBUG+MPP_DEBUG_LEVEL_4,
					"mpp_FailPath: %s:%d:%d still good\n", RdacInfo->ModuleName, Controller, i));
					AnotherPathAvailable = 1;
					break;
				}
			}
			if( AnotherPathAvailable )
				break;
		}
	}
			
	MPP_UNLOCK(RdacInfo->Lock, LockLevel);
	if( FailedPath )
		MPP_ERRORLOGPRINT((MPP_ERR_PATH_FAILOVER, 7, "%s:%d:%d Path Failed\n",
		RdacInfo->ModuleName, Controller, Path));
	
	return(AnotherPathAvailable);
		
}
/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_IsFailoverPossible
* SUMMARY:  Check for alternate paths to this controller and/or to the alternate controller
*		level indicates if it is controller (1) or path (0) failover
*
*	Returns: 1 = Failover is possible
*			 0 = Failover not possible
*/
BYTE 
mpp_IsFailoverPossible(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, BYTE Lun, BYTE level)
{
	LINT LockLevel;
	BYTE i;

	MPP_LOCK(RdacInfo->Lock, LockLevel);
	
	if( !level ) {
		/* 1st check for more paths to this controller */
		for(i=0; i<mpp_MaxPathsPerController; ++i) {
			if( !RdacInfo->ControllerInfo[Controller]->ControllerPath[i].Failed &&
		    	(i != Path) &&
		    	RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[i].LunPathDevice &&
		    	mpp_CheckPathGood(RdacInfo, Controller, i, Lun) ) {
				MPP_UNLOCK(RdacInfo->Lock, LockLevel);
				return(1);
			}
		}
	}
	/* No paths to this controller available - check the alternate */
	if( !RdacInfo->ControllerInfo[Controller^1]->ControllerPresent ||
	    RdacInfo->ControllerInfo[Controller^1]->Failed  ) {
	    	/* no alternate controller */
		MPP_UNLOCK(RdacInfo->Lock, LockLevel);
		return(0);    
	}	

	/* 2nd check for more paths to this alternate controller */
	for(i=0; i<mpp_MaxPathsPerController; ++i) {
		if( !RdacInfo->ControllerInfo[Controller^1]->ControllerPath[i].Failed &&
		    RdacInfo->RdacLuns[Lun].LunControllers[Controller^1]->LunPaths[i].LunPathDevice &&
		    mpp_CheckPathGood(RdacInfo, (BYTE) (Controller^1), i, Lun) ) {
			MPP_UNLOCK(RdacInfo->Lock, LockLevel);
			return(1);
		}
	}
			
	MPP_UNLOCK(RdacInfo->Lock, LockLevel);
	
	return(0);
		
}


BOOL
mpp_CreatePage2CSubPageRebalance(ModePage2CSubPage_t *page2C, BYTE *cdb, int Controller, 
	RdacLunInformation_t RdacLuns[])
{
	unsigned int i;
	BOOL MovedLuns = FALSE;
	
	page2C->PageLength[0] = 0x01;
	page2C->PageLength[1] = 0x28;
	page2C->SubPageCode = 0x01;
	page2C->PageCode = 0x2c + 0x40; /* Page 0x2C with the SPF bit set to 1 */
	page2C->RDAC_Mode[1] = 0x02; /* dual active mode */

	page2C->QuiescenceTimeout = (BYTE) mpp_FailOverQuiescenceTime;
	page2C->RDACOptions = RDAC_FORCED_QUIESENCE;
	
	/* package the controller LUN table to transfer ownership back to preferred path */
	for(i = 0; (i < 256) && (i < mpp_MaxLunsPerArray); i++)
	{
		if ((RdacLuns[i].PreferredPath == Controller) && (RdacLuns[i].CurrentOwningPath != Controller) &&
			!RdacLuns[i].UTMLun && RdacLuns[i].Present)
		{
			/* found a LUN that needs to be on this controller */
			page2C->ControllerLunTable[i] = 0x81;
			MovedLuns = TRUE;
		}
	}
	
	*cdb = SCSI_MODE_SELECT;
	*(cdb+1) = 1;
   	*(cdb+7) = (sizeof(ModePage2CSubPage_t) >> 8);
	*(cdb+8) = sizeof(ModePage2CSubPage_t) & 0x00ff;
	
	return MovedLuns;
}


BOOL
mpp_CreatePage2CRebalance(ModePage2C_t *page2C, BYTE *cdb, int Controller, 
	RdacLunInformation_t RdacLuns[])
{
	unsigned int i;
	BOOL MovedLuns = FALSE;
	
	page2C->PageLength = 0x68;
	page2C->PageCode = PAGE_CODE_REDUNDANT_CONTROLLER;
	page2C->RDAC_Mode[1] = 0x02; /* dual active mode */

	page2C->QuiescenceTimeout = (BYTE) mpp_FailOverQuiescenceTime;
	page2C->RDACOptions = RDAC_FORCED_QUIESENCE;

	/* package the controller LUN table to transfer ownership back to preferred path */
	for(i = 0; (i < 64) && (i < mpp_MaxLunsPerArray); i++)
	{
		if ((RdacLuns[i].PreferredPath == Controller) && (RdacLuns[i].CurrentOwningPath != Controller) &&
			!RdacLuns[i].UTMLun && RdacLuns[i].Present)
		{
			/* found a LUN that needs to be on this controller */
			page2C->ControllerLunTable[i] = 0x81;
			MovedLuns = TRUE;
		}
	}
	
	*cdb = SCSI_MODE_SELECT;

	*(cdb+1) = 1;
	*(cdb+8) = sizeof(ModePage2C_t);
	
	return MovedLuns;
}


void
mpp_CreatePage2CFailoverCommand(ModePage2C_t *page2C, BYTE *cdb)
{
	page2C->PageLength = 0x68;
	page2C->PageCode = PAGE_CODE_REDUNDANT_CONTROLLER;
	page2C->RDAC_Mode[1] = ACTIVE_MODE; /* switch to active/passive - this one active */

	/* 06/05/02 - Added option to hold the Alternate controller in reset.  This is necessary
	 * for w2k systems running MSCS where a system is configured in such a way that one node
	 * only sees the 'A' controller and the other node only sees the 'B' controller.  MSCS
	 * must be able to issue reservation/release commands to both controllers.  By holding the
	 * alternate in reset it has the side-effect of preventing one of the nodes from successfully
	 * taking over luns.
	 */
	if(mpp_HoldAltInReset)
		page2C->AltRDACMode[1] = RDAC_RESET_ALTERNATE;
	
	page2C->QuiescenceTimeout = (BYTE) mpp_FailOverQuiescenceTime;
	page2C->RDACOptions = RDAC_FORCED_QUIESENCE;

    	*cdb = SCSI_MODE_SELECT;

    	*(cdb+1) = 1;
    	*(cdb+8) = sizeof(ModePage2C_t);
}


void
mpp_CreatePage2CSubPageFailoverCommand(ModePage2CSubPage_t *page2C, BYTE *cdb)
{
	page2C->PageLength[0] = 0x01;
	page2C->PageLength[1] = 0x28;
	page2C->SubPageCode = 0x01;
	//page2C->PageCode = PAGE_CODE_REDUNDANT_CONTROLLER;
	page2C->PageCode = 0x2c + 0x40; /* Page 0x2C with the SPF bit set to 1 */
	page2C->RDAC_Mode[1] = ACTIVE_MODE; /* switch to active/passive - this one active */

	/* 06/05/02 - Added option to hold the Alternate controller in reset.  This is necessary
	 * for w2k systems running MSCS where a system is configured in such a way that one node
	 * only sees the 'A' controller and the other node only sees the 'B' controller.  MSCS
	 * must be able to issue reservation/release commands to both controllers.  By holding the
	 * alternate in reset it has the side-effect of preventing one of the nodes from successfully
	 * taking over luns.
	 */
	if(mpp_HoldAltInReset)
		page2C->AltRDACMode[1] = RDAC_RESET_ALTERNATE;
	
	page2C->QuiescenceTimeout = (BYTE) mpp_FailOverQuiescenceTime;
	page2C->RDACOptions = RDAC_FORCED_QUIESENCE;

    	*cdb = SCSI_MODE_SELECT;
    	*(cdb+1) = 1;
   	*(cdb+7) = (sizeof(ModePage2CSubPage_t) >> 8);
    	*(cdb+8) = sizeof(ModePage2CSubPage_t) & 0x00ff;
}


/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_FailController
* SUMMARY:  Fail the given Controller 
*/
BYTE 
mpp_FailController(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Lun)
{
	LINT LockLevel;
	BYTE i, path, FailController=0, markFailed = 0;
	VOID	*Page2C;
	BYTE *cdb;
	MPP_HANDLE FailoverHandle=NULL;

	MPP_LOCK(RdacInfo->Lock, LockLevel);

	/*
	 * 05/13/03 - This function can be called as the result of a FAILBACK_TO_CURRENT request.
	 * In a PnP environment (aka Windows) its possible that I/O's may be sent to the virtual
	 * disk before all paths have been found, resulting in a condition where the only path
	 * available is the unowned path.  The controller will return a LUN_NOT_OWNED status when
	 * this happens.  If the FailbackToCurrent option is enabled this will result in a failover
	 * request being issued against the controller which received the original I/O request.
	 * Because of the way in which this function was written the alternate controller index
	 * is passed in.  For example, Lun 0 is owned by the 'B' controller but the only path we
	 * have is to the 'A' controller.  The controller index passed into this function would
	 * represent the 'B' controller.  The problem with the logic below is that it always marks
	 * the controller as failed even if no paths currently exist to that controller.  This will
	 * result in the controller state being Failed while any future paths are marked as
	 * Unfailed.  The failback scan process does not Unfail controllers unless one of the paths
	 * to that controller is Failed.  One could argue whether the logic should be added in the
	 * FailBack process to account for this, but at the very least this function should not
	 * mark a controller as failed if none of the paths exist.
	 */
	if( !RdacInfo->ControllerInfo[Controller]->Failed ) {
		for( path=0; path<mpp_MaxPathsPerController; ++path ) {
			if( !RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Present )
				continue;

			RdacInfo->ControllerInfo[Controller]->ControllerPath[path].Failed = TRUE;
			markFailed = 1;
		}

		if(markFailed)
		{
			RdacInfo->ControllerInfo[Controller]->Failed = TRUE;
		}
		else
		{
			RdacInfo->ControllerInfo[Controller]->Failed = FALSE;
		}

		FailController = 1;
	}
			
	MPP_UNLOCK(RdacInfo->Lock, LockLevel);

	/*FailController = 1;*/

	if(FailController) {
		if( !RdacInfo->AVTEnabled && 
		    !RdacInfo->ControllerInfo[Controller^1]->FailoverInProgress)
		{
			if(RdacInfo->Page2CSubPage1)
				Page2C = (ModePage2CSubPage_t *) MPP_INT_KMEM_ALLOC(sizeof(ModePage2CSubPage_t)+10);
			else
			        Page2C = (ModePage2C_t *) MPP_INT_KMEM_ALLOC(sizeof(ModePage2C_t)+10);

			if(!Page2C) {
				MPP_LOCK(RdacInfo->Lock, LockLevel);
	      			RdacInfo->ControllerInfo[Controller]->Failed = FALSE;
				MPP_UNLOCK(RdacInfo->Lock, LockLevel);

				MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 8, 
				"%s:%d Failover Failed could not alloc memory\n",
				RdacInfo->ModuleName, Controller));
				return(0);
			}

			// 11/02/02 - mpp_CreateFailoverCommand has been replaced by new functions which build
			// the appropriate Page2C failover command depending on whether it supports 32 or 256
			// luns per partition.
			if(RdacInfo->Page2CSubPage1)
			{
				cdb = ((BYTE *) Page2C) + sizeof(ModePage2CSubPage_t);
				mpp_CreatePage2CSubPageFailoverCommand(Page2C, cdb);
			}
			else
			{
			        cdb = ((BYTE *) Page2C) + sizeof(ModePage2C_t);
				mpp_CreatePage2CFailoverCommand(Page2C, cdb);
			}

			for( i=0; i<mpp_MaxPathsPerController; ++i) {
				if( !RdacInfo->ControllerInfo[Controller^1]->ControllerPath[i].Failed &&
				     RdacInfo->RdacLuns[Lun].LunControllers[Controller^1]->LunPaths[i].LunPathDevice &&
				     mpp_CheckPathGood(RdacInfo, (BYTE) (Controller^1), i, Lun) ) {
					FailoverHandle = 
					RdacInfo->RdacLuns[Lun].LunControllers[Controller^1]->LunPaths[i].LunPathDevice;
					break;
				}
			}
			if( FailoverHandle && (i != mpp_MaxPathsPerController) ) {
				RdacInfo->ControllerInfo[Controller^1]->FailoverInProgress = TRUE;
				mpp_IssueFailover(RdacInfo, (BYTE) (Controller^1), i, FailoverHandle, (BYTE *) Page2C, cdb);
				MPP_ERRORLOGPRINT((MPP_ERR_CTLR_FAILOVER, 10, "%s:%d Failover command issued\n",
				RdacInfo->ModuleName, Controller));
			} else {
				MPP_LOCK(RdacInfo->Lock, LockLevel);
	      			RdacInfo->ControllerInfo[Controller]->Failed = FALSE;
				MPP_UNLOCK(RdacInfo->Lock, LockLevel);
				MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 9, 
				"%s:%d Failover Failed no path to Lun %d via controller %d\n",
				RdacInfo->ModuleName, Controller, Lun, Controller^1));
				return(0);
			}
		} else {
			if( RdacInfo->AVTEnabled ) { 
				MPP_ERRORLOGPRINT((MPP_ERR_CTLR_FAILOVER, 106, "%s:%d:%d AVT Failover\n",
				RdacInfo->ModuleName, Controller, Lun));
			} else {
				MPP_DEBUGPRINT((MPP_FAILOVER_IO_DEBUG+MPP_DEBUG_LEVEL_3,
				"mpp_FailController:s:%d Failover In Progress - skip failover command\n",
				RdacInfo->ModuleName, Controller));
			}
		}

	}
	
	return(1);
		
}

/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_IsAnotherPathAvailableForFailover
* SUMMARY:  Check for another path to the "good" controller
*/
BYTE 
mpp_IsAnotherPathAvailableForFailover(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, BYTE Lun)
{
	BYTE i;

	for(i=0; i<mpp_MaxPathsPerController; ++i) {
		if( (i != Path) &&
		    RdacInfo->ControllerInfo[Controller]->ControllerPath[i].Present &&
		    !RdacInfo->ControllerInfo[Controller]->ControllerPath[i].Failed &&
		    RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[i].LunPathDevice )
		    	return(1);
	}
	return(0);
}


/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_AnalyseFailoverError
* SUMMARY:  Analyse a failover command error
*/
LWORD 
mpp_AnalyseFailoverError(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, BYTE Lun, LWORD mppStatus, 
			SenseData_t *SenseData, SINT SenseLength, LWORD DataLengthXfered, MPP_TIME StartTime)
{
	BYTE AnotherPathAvailable;
	MPP_TIME CurrentTime;
	
	MPP_GETTIME(CurrentTime);
	if( !((CurrentTime - StartTime) % 60)  && (CurrentTime != StartTime) ) {
		MPP_DEBUGPRINT((MPP_FAILOVER_IO_DEBUG+MPP_DEBUG_LEVEL_4,
		"mpp_AnalyseFailoverError: CurrentTime 0x%x, StartTime 0x%x\n", CurrentTime, StartTime));
	}
	AnotherPathAvailable = mpp_IsAnotherPathAvailableForFailover(RdacInfo, Controller, Path, Lun);

	switch(mppStatus) {
		case MPP_GOOD_STATUS:
			if( DataLengthXfered )
				return(MPP_NO_FAILOVER_ERROR);
			MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 11, "Failover: Good Status but no data\n"));
			return(MPP_RETRY_FAILOVER);
				
		case MPP_CHECK_CONDITION:
    			MPP_DEBUGPRINT((MPP_FAILOVER_IO_DEBUG+MPP_DEBUG_LEVEL_2, 
			"mpp_AnalyseFailoverError: Check Condition, sense data length %d\n",
			SenseLength));
			if( SenseLength < 3 ) {
				MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 12, "Failover: Check Condition but no Sense data\n"));
				return(MPP_RETRY_FAILOVER);
			}

    			MPP_DEBUGPRINT((MPP_FAILOVER_IO_DEBUG+MPP_DEBUG_LEVEL_1, "mpp_AnalyseFailoverError: Sense Key %d\n", SenseData->Sense_Key));
			switch( SenseData->Sense_Key ) {
				case SENSE_KEY_ABORTED_COMMAND:
				case SENSE_KEY_NO_SENSE:
					MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 13, "Failover: retryable Error SK 0x%x, ASC/ASCQ 0x%x/0x%x\n",
					SenseData->Sense_Key,SenseData->ASC, SenseData->ASCQ));
					return(MPP_RETRY_FAILOVER);

				case SENSE_KEY_RECOVERED_ERROR:
					MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 14, 
					"Failover: Recoverd Error SK, ASC/ASCQ 0x%x/0x%x\n",
					SenseData->ASC, SenseData->ASCQ)); 
					
					return(MPP_NO_FAILOVER_ERROR);

				case SENSE_KEY_NOT_READY:
					if( SenseLength < 12 ) {
						MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 15, 
						"Failover: Not ready but no ASC/ASCQ\n")); 
						return(MPP_RETRY_FAILOVER);
					}
					MPP_DEBUGPRINT((MPP_FAILOVER_IO_DEBUG+MPP_DEBUG_LEVEL_1, 
					"mpp_AnalyseFailoverError: Not Ready ASC/ASCQ 0x%x/0x%x\n", 
					SenseData->ASC, SenseData->ASCQ));
					if( (SenseData->ASC == ASC_NOT_READY) && (SenseData->ASCQ == ASCQ_BECOMING_READY) ) {
						if( (CurrentTime - StartTime) > mpp_NotReadyWaitTime ) {
							MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 16, "Not Ready Wait Time exceeded\n")); 
							return(MPP_RETURN_FAILOVER_ERROR);
						}	
						return(MPP_RETRY_FAILOVER);
					}
					MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 17, 
					"Failover: Not ready & Not becoming ready\n")); 
					return(MPP_RETURN_FAILOVER_ERROR);
					
				case SENSE_KEY_ILLEGAL_REQUEST:
					if( (SenseData->ASC == ASC_MODE_ERROR) && (SenseData->ASCQ == ASCQ_CMD_LOCK_VIOLATION) ) {
						MPP_ERRORLOGPRINT((MPP_ERR_ALL, 18, 
						"Failover: Command Lock Violation\n"));
						return(MPP_RETRY_FAILOVER);
					}
					MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 19, 
					"Failover: Illegal Request ASC/ASCQ 0x%x/0x%x, SKSBs 0x%x/0x%x/0x%x\n", 
					SenseData->ASC, SenseData->ASCQ, SenseData->Sense_Key_Specific_Info[0], 
					SenseData->Sense_Key_Specific_Info[1], SenseData->Sense_Key_Specific_Info[2]));

					return(MPP_RETURN_FAILOVER_ERROR);

				case SENSE_KEY_UNIT_ATTENTION:
					MPP_DEBUGPRINT((MPP_FAILOVER_IO_DEBUG+MPP_DEBUG_LEVEL_1, 
					"mpp_AnalyseFailoverError: UA ASC/ASCQ 0x%x/0x%x\n", 
					SenseData->ASC, SenseData->ASCQ));
					if( (SenseLength > 12) &&
					    (SenseData->ASC == ASC_QUIESCENCE) && (SenseData->ASCQ == ASCQ_QUIESCENCE_IN_PRGS) ) {
						if( (CurrentTime - StartTime) > mpp_QuiescenceWaitTime ) {
							MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 20, 
							"Failover: Quiescence Wait Time exceeded\n")); 
							return(MPP_RETURN_FAILOVER_ERROR);
						}	
						return(MPP_RETRY_FAILOVER);
					}
					if( SenseLength > 12) {
						MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 21, 
						"Failover: Ua, ASC/ASCQ 0x%x/0x%x, fru 0x%x\n",
						SenseData->ASC, SenseData->ASCQ, SenseData->Field_Replaceable_Unit)); 
					}

					
					return(MPP_RETRY_FAILOVER);

				case SENSE_KEY_HARDWARE_ERROR:
					if( SenseLength > 12) {
						MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 22, 
						"Failover: Hardware Error ASC/ASCQ 0x%x/0x%x, fru 0x%x\n",
						SenseData->ASC, SenseData->ASCQ, SenseData->Field_Replaceable_Unit)); 
					}
					if( AnotherPathAvailable )
						return(MPP_RETRY_FAILOVER);
					return(MPP_RETURN_FAILOVER_ERROR);

				default:
					MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 23, "Failover: Unrecognized SK - %d\n",
					SenseData->Sense_Key)); 
					return(MPP_RETURN_FAILOVER_ERROR);
			}	
		 
		case MPP_SCSI_BUSY:
			if( (CurrentTime - StartTime) > mpp_BusyWaitTime ) {
				MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 24, "Failover: Busy Wait Time exceeded\n")); 
				return(MPP_RETURN_FAILOVER_ERROR);
			}
			return(MPP_RETRY_FAILOVER);
		 
		case MPP_SELECTION_TIMEOUT:
			MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 25, "Failover: Retrying Selection Timeout\n"));
			if( AnotherPathAvailable )
				return(MPP_RETRY_FAILOVER);
			return(MPP_RETURN_FAILOVER_ERROR);

		case MPP_SCSI_RESERVATION:
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL,26, "Failover: Reservation Conflict\n")); 
			return(MPP_RETURN_FAILOVER_ERROR); 
		case MPP_INVALID_REQUEST: 
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 27, "Failover: Illegal Command\n")); 
			return(MPP_RETURN_FAILOVER_ERROR);

		case MPP_COMMAND_TIMEOUT: 
			 MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 28, "Failover: command Timeout\n")); 
			 return(MPP_RETURN_FAILOVER_ERROR);

		case MPP_UNSUPPORTED_SCSI_STATUS: 
		case MPP_HARDWARE_ERROR: 
		case MPP_COMMAND_ABORTED: 
		case MPP_UNRECOGNIZED_OS_STATUS: 
		case MPP_REQUEST_SENSE_FAILED:
		default:
			MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 29, "Failover: Retrying mpp status %d\n", mppStatus)); 
			return(MPP_RETURN_FAILOVER_ERROR);
	}
}

/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_AnalyseIoError
* SUMMARY:  
* SCOPE:    private 
*
*
* DESCRIPTION: This routine determines the appropriate action to take when a SCSI I/O, via scsi_command is returned.
*
* 03/03/03 - Reworked the ErrorLog printing due to the Windows platform truncating the errorlog text.
*/
LWORD 
mpp_AnalyseIoError(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, BYTE Lun, LWORD mpp_status, 
			SenseData_t *SenseData, SINT SenseLength, LWORD DataLengthXfered, MPP_TIME StartTime,
			BYTE *SelectionTimeoutRetryCount, BYTE *CommandTimeoutRetryCount, BYTE *UaRetryCount, BYTE *RetryCount,
			MPP_TIME ControllerIoWaitTime, MPP_TIME ArrayIoWaitTime)
{
	MPP_TIME CurrentTime;
	LWORD ReturnStatus;
	LWORD ErrorLevel= MPP_ERR_ALL;
	LINT LockLevel;
	TINY AdditionalErrorString[100];
	LWORD ErrorNumber = 0;

	MPP_GETTIME(CurrentTime);
	bzero(&AdditionalErrorString[0], 100);
	if( !((CurrentTime - StartTime) % 60)  && (CurrentTime != StartTime) ) {
		MPP_DEBUGPRINT((MPP_HBA_COMMAND_DEBUG+MPP_DEBUG_LEVEL_4,
		"mpp_AnalyseIoError: CurrentTime 0x%x, StartTime 0x%x\n", CurrentTime, StartTime));
	}

	switch(mpp_status) {
		case MPP_GOOD_STATUS:
			if( DataLengthXfered ) {
				sprintf(&AdditionalErrorString[0], "Good Status & %d data bytes xferred\n", DataLengthXfered);
				ErrorLevel = MPP_ERR_ALL;
				ErrorNumber = 104;
				ReturnStatus = MPP_NO_ERROR;
				break;
			}
			ErrorLevel = MPP_ERR_RETRYABLE;
			ErrorNumber = 76; 
			sprintf(&AdditionalErrorString[0], "Good Status but no data\n");
			ReturnStatus = MPP_RETRY_DEC_COUNT;
			break;
				
		case MPP_CHECK_CONDITION:
    			MPP_DEBUGPRINT((MPP_HBA_COMMAND_DEBUG+MPP_DEBUG_LEVEL_2, "mpp_AnalyseIoError: Check Condition, sense data length %d\n",
			SenseLength));
			if( SenseLength < 3 ) {
				ErrorLevel = MPP_ERR_RETRYABLE;
				ErrorNumber = 77; 
				sprintf(&AdditionalErrorString[0], "Check Condition but no Sense data\n");
				ReturnStatus = MPP_RETRY_DEC_COUNT;
				break;
			}

    			MPP_DEBUGPRINT((MPP_HBA_COMMAND_DEBUG+MPP_DEBUG_LEVEL_1, "mpp_AnalyseIoError: Sense Key %d\n", SenseData->Sense_Key));
			switch( SenseData->Sense_Key ) {
				case SENSE_KEY_ABORTED_COMMAND:
				case SENSE_KEY_NO_SENSE:
					ErrorLevel = MPP_ERR_RETRYABLE;
					ErrorNumber = 78;
					sprintf(&AdditionalErrorString[0],  "retryable Error SK 0x%x\n",
					SenseData->Sense_Key);
					ReturnStatus = MPP_RETRY_DEC_COUNT;
					break;
				case SENSE_KEY_RECOVERED_ERROR:
					ErrorLevel = MPP_ERR_RECOVERED;
					ErrorNumber =  79;
					sprintf(&AdditionalErrorString[0], "Recoverd Error SK, ASC/ASCQ 0x%x/0x%x\n",
						SenseData->ASC, SenseData->ASCQ); 
					
					ReturnStatus = MPP_NO_ERROR;
					break;
				case SENSE_KEY_NOT_READY:
					if( SenseLength < 12 ) {
						ErrorLevel = MPP_ERR_RETRYABLE;
						ErrorNumber = 80;
						sprintf(&AdditionalErrorString[0], "Not ready but no ASC/ASCQ\n"); 
						ReturnStatus = MPP_RETRY_DEC_COUNT;
						break;
					}
					MPP_DEBUGPRINT((MPP_HBA_COMMAND_DEBUG+MPP_DEBUG_LEVEL_1, "mpp_AnalyseIoError: Not Ready ASC/ASCQ 0x%x/0x%x\n", 
					SenseData->ASC, SenseData->ASCQ));
					if( (SenseData->ASC == ASC_NOT_READY) && (SenseData->ASCQ == ASCQ_BECOMING_READY) ) {
						if( RdacInfo->RdacLuns[Lun].NotReady ||
						    (RdacInfo->RdacLuns[Lun].NotReadyStart &&
						     ((CurrentTime - RdacInfo->RdacLuns[Lun].NotReadyStart) > mpp_NotReadyWaitTime)) ) {
							RdacInfo->RdacLuns[Lun].NotReady = TRUE;
							ErrorLevel = MPP_ERR_FATAL;
							ErrorNumber = 81;
							sprintf(&AdditionalErrorString[0], "Not Ready Wait Time exceeded\n");
							if( mpp_IsFailoverPossible(RdacInfo, Controller, Path, Lun, 1) )
								ReturnStatus = MPP_FAILOVER_CONTROLLER;
			 				else
								ReturnStatus = MPP_RETURN_ERROR; 
							break;
						} else {
							if( !RdacInfo->RdacLuns[Lun].NotReadyStart )
								RdacInfo->RdacLuns[Lun].NotReadyStart = CurrentTime;
						}	
						ReturnStatus = MPP_RETRY_NO_DEC;
						break;
					}
					/* 
					 * This case is for a pass through command to a drive.
					 * The controller never returns an 04/02 status, just pass this IO back.
					 */
					if ((SenseData->ASC == ASC_NOT_READY) && (SenseData->ASCQ == 0x02))
					{
						ReturnStatus = MPP_NO_ERROR;
						break;
					}
					
					/*
					 * Check if the LUN is being formatted 
					 */
					if ((SenseData->ASC == ASC_NOT_READY) && (SenseData->ASCQ == ASCQ_FORMAT_IN_PROGRESS))
					{
						ReturnStatus = MPP_RETURN_ERROR;
						ErrorLevel = MPP_ERR_FATAL;
						sprintf(AdditionalErrorString, "Lun format in progress\n");
						break;
					}
			
					ErrorLevel = MPP_ERR_FATAL;
					ErrorNumber = 82;
					sprintf(&AdditionalErrorString[0], "Not ready & Not becoming ready ASC/ASCQ 0x%x/0x%x\n",
					SenseData->ASC, SenseData->ASCQ);
					if( mpp_IsFailoverPossible(RdacInfo, Controller, Path, Lun, 1) )
						ReturnStatus = MPP_FAILOVER_CONTROLLER;
			 		else
						ReturnStatus = MPP_RETURN_ERROR; 
					break;
					
				case SENSE_KEY_ILLEGAL_REQUEST:
					if( SenseData->ASC == LUN_NOT_OWNED ) {
						BYTE i;
						if((mppSys_AreControllerPathsFailed(RdacInfo, Controller^1, Lun) ||
						   	! RdacInfo->ControllerInfo[Controller^1]->ControllerPresent || 
							RdacInfo->ControllerInfo[Controller^1]->Failed) && 
							! RdacInfo->ControllerInfo[Controller]->FailoverInProgress && 
							mpp_FailBackToCurrentAllowed ) 
						{
							ErrorLevel = MPP_ERR_RETRYABLE;
							ErrorNumber = 83;
							sprintf(&AdditionalErrorString[0],"Lun Not owned - No Alternate\n");
							ReturnStatus = MPP_FAILOVER_TO_CURRENT;
							break;
						}

					
						if((mppSys_AreControllerPathsFailed(RdacInfo, Controller^1, Lun) ||
							! RdacInfo->ControllerInfo[Controller^1]->ControllerPresent || 
							RdacInfo->ControllerInfo[Controller^1]->Failed) && 
							! RdacInfo->ControllerInfo[Controller]->FailoverInProgress && 
							! mpp_FailBackToCurrentAllowed)
						{
							/* failover to current not allowed..because of thrashing*/
							ErrorLevel = MPP_ERR_FATAL;
							ErrorNumber = 112;  /*FIX THIS NUMBER FOR SOLARIS*/
							sprintf(&AdditionalErrorString[0],"Lun Not owned - Failover to alternate not allowed\n");
							ReturnStatus = MPP_RETURN_ERROR;
							break;
						}
						if (RdacInfo->ControllerInfo[Controller]->FailoverInProgress)
						{
							/* retry to same controller while failover in progress*/
							ReturnStatus = MPP_RETRY_NO_DEC;
							break;
						}
						MPP_LOCK(RdacInfo->Lock, LockLevel);
						if( RdacInfo->ControllerInfo[Controller^1]->Failed ) {
							for(i=0; i<mpp_MaxPathsPerController; ++i) {
								RdacInfo->ControllerInfo[Controller^1]->ControllerPath[i].Failed = FALSE;
							}

							RdacInfo->ControllerInfo[Controller^1]->Failed = FALSE;
						}
						MPP_UNLOCK(RdacInfo->Lock, LockLevel);
						ErrorLevel = MPP_ERR_ALL;
						ErrorNumber = 84;
						sprintf(&AdditionalErrorString[0],"Lun Not owned\n");
						ReturnStatus = MPP_RETRY_ALTERNATE_CONTROLLER;


						break; 
					}
					sprintf(&AdditionalErrorString[0], 
					"Illegal Request ASC/ASCQ 0x%x/0x%x, SKSBs 0x%x/0x%x/0x%x\n", 
					SenseData->ASC, SenseData->ASCQ, SenseData->Sense_Key_Specific_Info[0], 
					SenseData->Sense_Key_Specific_Info[1], SenseData->Sense_Key_Specific_Info[2]);
					ErrorLevel = MPP_ERR_FATAL;
					ErrorNumber = 85;
					ReturnStatus = MPP_RETURN_ERROR;
					break;

				case SENSE_KEY_UNIT_ATTENTION:
					MPP_DEBUGPRINT((MPP_HBA_COMMAND_DEBUG+MPP_DEBUG_LEVEL_1, 
					"mpp_AnalyseIoError: UA ASC/ASCQ 0x%x/0x%x\n", 
					SenseData->ASC, SenseData->ASCQ));
					if( (SenseLength > 12) &&
					    (SenseData->ASC == ASC_QUIESCENCE) && (SenseData->ASCQ == ASCQ_QUIESCENCE_IN_PRGS) ) {
						if( RdacInfo->RdacLuns[Lun].Quiescent ||
						    (RdacInfo->RdacLuns[Lun].QuiescienceStart &&
						     ((CurrentTime - RdacInfo->RdacLuns[Lun].QuiescienceStart) > mpp_QuiescenceWaitTime)) ) {
						    	RdacInfo->RdacLuns[Lun].Quiescent = TRUE;
							ErrorLevel = MPP_ERR_FATAL;
							ErrorNumber = 86;
							sprintf(&AdditionalErrorString[0], "Quiescence Wait Time exceeded\n"); 
							if( mpp_IsFailoverPossible(RdacInfo, Controller, Path, Lun, 1) )
								ReturnStatus = MPP_FAILOVER_CONTROLLER;
					 		else
					 		{
					 			/* mark this controller as failed */
					 			mpp_FailPath(RdacInfo, Controller, Path);
								RdacInfo->ControllerInfo[Controller]->Failed = TRUE;
								ReturnStatus = MPP_RETURN_ERROR; 
							}
							break;
						} else {
							if( !RdacInfo->RdacLuns[Lun].QuiescienceStart )
								RdacInfo->RdacLuns[Lun].QuiescienceStart = CurrentTime;
						}
						ErrorLevel = MPP_ERR_ALL;
						ErrorNumber = 105;	
						sprintf(&AdditionalErrorString[0], "Quiescence In Progress\n"); 
						ReturnStatus = MPP_RETRY_NO_DEC;
						break;
					}
					if( SenseLength > 12) {
						ErrorLevel = MPP_ERR_RECOVERED;
						ErrorNumber = 87;
						sprintf(&AdditionalErrorString[0], "Ua, ASC/ASCQ 0x%x/0x%x, fru 0x%x\n",
						SenseData->ASC, SenseData->ASCQ, SenseData->Field_Replaceable_Unit); 
					}

					*UaRetryCount += 1;

					if( *UaRetryCount <= mpp_UaRetryCount ) {
						if ( mpp_DoUARetry )
						{
							ReturnStatus = MPP_RETRY_NO_DEC;
						}
						else
						{
							ReturnStatus = MPP_NO_ERROR;
						}
						break;						
					}

					ErrorLevel = MPP_ERR_FATAL;
					ErrorNumber =  88;
					sprintf(&AdditionalErrorString[0], "UA Retry count exhausted, ASC/ASCQ 0x%x/0x%x, fru 0x%x\n",
					SenseData->ASC, SenseData->ASCQ, SenseData->Field_Replaceable_Unit);
					if( mpp_IsFailoverPossible(RdacInfo, Controller, Path, Lun, 1) )
						ReturnStatus = MPP_FAILOVER_CONTROLLER;
			 		else
			 		{
			 			/* mark this controller as failed */
			 			mpp_FailPath(RdacInfo, Controller, Path);
						RdacInfo->ControllerInfo[Controller]->Failed = TRUE;
						ReturnStatus = MPP_RETURN_ERROR; 
					}
					break;
				case SENSE_KEY_HARDWARE_ERROR:
					sprintf(&AdditionalErrorString[0], "Hardware error, ASC/ASCQ 0x%x/0x%x, fru 0x%x\n",
							SenseData->ASC, SenseData->ASCQ, SenseData->Field_Replaceable_Unit);
					ErrorLevel = MPP_ERR_FATAL;
					switch(SenseData->ASC) {
	    					case  FORMAT_FAILED:
						case  OUT_OF_ALTERNATES:
						case  CONTROLLER_MSG_ERROR:
						case  DRIVE_SELECTION_TIMEOUT:
						case  OPERATION_NOT_ALLOWED:
						case  DRIVE_IO_ABORTED:
						case  DRIVE_ERROR:
						case  MICROCODE_DL_FAILED:
							ErrorNumber =  89;
							ReturnStatus = MPP_RETURN_ERROR;
							break;
						default:
							ErrorNumber =  90;
							ReturnStatus = MPP_RETRY_DEC_COUNT;
							break;
					}
					break;

				default:
					ErrorLevel = MPP_ERR_FATAL;
					ErrorNumber = 91;
					sprintf(&AdditionalErrorString[0], "Unrecognized SK - %d\n",
					SenseData->Sense_Key); 
					ReturnStatus = MPP_RETURN_ERROR;
					break;
			}
			break;	
		 
		case MPP_SCSI_BUSY:
			if( RdacInfo->RdacLuns[Lun].Busy ||
			    (RdacInfo->RdacLuns[Lun].BusyStart &&
			     ((CurrentTime - RdacInfo->RdacLuns[Lun].BusyStart) > mpp_BusyWaitTime)) ) {
			    RdacInfo->RdacLuns[Lun].Busy = TRUE;
				ErrorLevel = MPP_ERR_FATAL;
				ErrorNumber = 92;
				sprintf(&AdditionalErrorString[0], "Busy Wait Time exceeded\n");
				if( mpp_IsFailoverPossible(RdacInfo, Controller, Path, Lun, 1) )
					ReturnStatus = MPP_FAILOVER_CONTROLLER;
			 	else
		 		{
		 			/* mark this controller as failed */
		 			mpp_FailPath(RdacInfo, Controller, Path);
		 			RdacInfo->ControllerInfo[Controller]->Failed = TRUE;
					ReturnStatus = MPP_RETURN_ERROR; 
				}
				break;
			} else {
				if( !RdacInfo->RdacLuns[Lun].BusyStart )
					RdacInfo->RdacLuns[Lun].BusyStart = CurrentTime;
			}
			ReturnStatus = MPP_RETRY_NO_DEC;
			break;
		 
		case MPP_SELECTION_TIMEOUT:
			*SelectionTimeoutRetryCount += 1;
			if( *SelectionTimeoutRetryCount <= mpp_SelectionTimeoutRetryCount ) {
				ErrorLevel = MPP_ERR_RETRYABLE;
				ErrorNumber = 93;
				sprintf(&AdditionalErrorString[0], "Retrying Selection Timeout %d\n",
					*SelectionTimeoutRetryCount); 
				ReturnStatus = MPP_RETRY_NO_DEC;
				break;
			}
			ErrorLevel = MPP_ERR_FATAL;
			ErrorNumber = 94;
			sprintf(&AdditionalErrorString[0], "Selection Retry count exhausted\n");
			if( mpp_IsFailoverPossible(RdacInfo, Controller, Path, Lun, 0) )
				ReturnStatus = MPP_FAILOVER;
			else
	 		{
	 			/* mark this controller as failed */
	 			mpp_FailPath(RdacInfo, Controller, Path);
	 			RdacInfo->ControllerInfo[Controller]->Failed = TRUE;
				ReturnStatus = MPP_RETURN_ERROR; 
			}
			break;
		case MPP_SCSI_RESERVATION:
			// 02/20/03 - Changed error level from FATAL to RECOVERED to reduce the
			// number of error messages produced when MSCS is used.
			ErrorLevel = MPP_ERR_RECOVERED;
			ErrorNumber = 95;
			sprintf(&AdditionalErrorString[0], "Reservation Conflict\n"); 
			ReturnStatus = MPP_RETURN_ERROR;
			break; 
		case MPP_INVALID_REQUEST: 
			ErrorLevel = MPP_ERR_FATAL;
			ErrorNumber = 96;
			sprintf(&AdditionalErrorString[0], "Illegal Command\n"); 
			ReturnStatus = MPP_RETURN_ERROR;
			break;

		case MPP_COMMAND_TIMEOUT: 
			*CommandTimeoutRetryCount += 1;
			 if( *CommandTimeoutRetryCount <= mpp_CommandTimeoutRetryCount ) {
				ErrorLevel = MPP_ERR_RETRYABLE;
				ErrorNumber = 97;
				sprintf(&AdditionalErrorString[0], "Retrying command Timeout\n"); 
				ReturnStatus = MPP_RETRY_NO_DEC;
				break;
			 }

			 ErrorLevel = MPP_ERR_FATAL;
			 ErrorNumber = 98;
			 sprintf(&AdditionalErrorString[0], "Command Timeout Retry count exhausted\n");
			 if( mpp_IsFailoverPossible(RdacInfo, Controller, Path, Lun, 1) )
				ReturnStatus = MPP_FAILOVER_CONTROLLER;
			 else
	 		{
	 			/* mark this controller as failed */
	 			mpp_FailPath(RdacInfo, Controller, Path);
	 			RdacInfo->ControllerInfo[Controller]->Failed = TRUE;
				ReturnStatus = MPP_RETURN_ERROR; 
			}
			 break;

		case MPP_UNSUPPORTED_SCSI_STATUS: 
		case MPP_HARDWARE_ERROR: 
		case MPP_COMMAND_ABORTED: 
		case MPP_UNRECOGNIZED_OS_STATUS: 
		case MPP_REQUEST_SENSE_FAILED:
		default:
			ErrorLevel = MPP_ERR_RETRYABLE;
			ErrorNumber = 99;
			sprintf(&AdditionalErrorString[0], "mpp status %d\n", mpp_status); 
			ReturnStatus = MPP_RETRY_DEC_COUNT;
			break;
	}
	
	/*
	 * Check if this IO has expired.
	 */
	if ( (CurrentTime - ControllerIoWaitTime) > mpp_ControllerIoWaitTime)
	{
		if( mpp_IsFailoverPossible(RdacInfo, Controller, Path, Lun, 1) )
		{
			ReturnStatus = MPP_FAILOVER_CONTROLLER;
		}
		else
		{
			/* mark this controller as failed */
			mpp_FailPath(RdacInfo, Controller, Path);
			RdacInfo->ControllerInfo[Controller]->Failed = TRUE;
			ReturnStatus = MPP_RETURN_ERROR; 
		}
		sprintf(AdditionalErrorString, "Controller IO time expired\n");
		ErrorLevel = MPP_ERR_FATAL;
	}
	else if ((CurrentTime - ArrayIoWaitTime) > mpp_ArrayIoWaitTime)
	{
		ReturnStatus = MPP_RETURN_ERROR;
		ErrorLevel = MPP_ERR_FATAL;
		sprintf(AdditionalErrorString, "Array IO time expired\n");
	}
	else if( ReturnStatus == MPP_RETRY_DEC_COUNT ) {
		*RetryCount -= 1;
	 	if( !(*RetryCount) ) {
			if( mpp_IsFailoverPossible(RdacInfo, Controller, Path, Lun, 0) )
				ReturnStatus = MPP_FAILOVER;
			else
				ReturnStatus = MPP_RETURN_ERROR;
			ErrorLevel = MPP_ERR_FATAL;
		}
	}

	MPP_ERRORLOGPRINT((ErrorLevel, ErrorNumber, "%s:%d:%d:%d %s", RdacInfo->ModuleName, Controller,
		Path, Lun, AdditionalErrorString));
	 
	return(ReturnStatus);

}
/*******************************************************************************
* PROCEDURE
*
* NAME:     
* SUMMARY:  mpp_AnalyseSyncError
* SCOPE:    private 
*
*
* DESCRIPTION: This routine determines the appropriate action to take when a synchronous I/O is returned.
*
* RESTRICTIONS: 
* 
* RETURNS: retry action
*
* ERRNO: 
*
* NOTES:
*
* EXAMPLES:  					 
*
* SEE ALSO: 
*
*/
LWORD 
mpp_AnalyseSyncError(LWORD mppStatus, SenseData_t *SenseData, LWORD SenseLengthReturned, 
			LWORD DataLengthXfered, MPP_TIME StartTime, LWORD *SelectionTimeoutRetryCount, 
			LWORD *CommandTimeoutRetryCount, LWORD *UaRetryCount)
{
	MPP_TIME CurrentTime;

	MPP_GETTIME(CurrentTime);
	if( !((CurrentTime - StartTime) % 60)  && (CurrentTime != StartTime) ) {
		MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AnalyseSyncError: CurrentTime 0x%x, StartTime 0x%x\n", CurrentTime, StartTime));
	}
	switch(mppStatus) {
		case MPP_GOOD_STATUS:
			if( DataLengthXfered )
				return(MPP_NO_ERROR);
			MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 30, "Synch IO: Good Status but no data\n"));
			return(MPP_RETRY_DEC_COUNT);
				
		case MPP_CHECK_CONDITION:
    			MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_2, "mpp_AnalyseSyncError: Check Condition, sense data length %d\n",
			SenseLengthReturned));
			if( SenseLengthReturned < 3 ) {
				MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 31, "Synch IO: Check Condition but no Sense data\n"));
				return(MPP_RETRY_DEC_COUNT);
			}

    			MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_1, "mpp_AnalyseSyncError: Sense Key %d\n", SenseData->Sense_Key));
			switch( SenseData->Sense_Key ) {
				case SENSE_KEY_ABORTED_COMMAND:
				case SENSE_KEY_NO_SENSE:
					MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 32, "Synch IO: retryable Error SK 0x%x\n",
					SenseData->Sense_Key));
					return(MPP_RETRY_DEC_COUNT);

				case SENSE_KEY_RECOVERED_ERROR:
					MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 33, "Synch IO: Recoverd Error SK, ASC/ASCQ 0x%x/0x%x\n",
					SenseData->ASC, SenseData->ASCQ)); 
					
					return(MPP_NO_ERROR);

				case SENSE_KEY_NOT_READY:
					if( SenseLengthReturned < 12 ) {
						MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 34, "Synch IO: Not ready but no ASC/ASCQ\n")); 
						return(MPP_RETRY_DEC_COUNT);
					}
					MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_1, "mpp_AnalyseSyncError: Not Ready ASC/ASCQ 0x%x/0x%x\n", 
					SenseData->ASC, SenseData->ASCQ));
					if( (SenseData->ASC == ASC_NOT_READY) && (SenseData->ASCQ == ASCQ_BECOMING_READY) ) {
						if( (CurrentTime - StartTime) > mpp_NotReadyWaitTime ) {
							MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 35, "Synch IO: Not Ready Wait Time exceeded\n")); 
							return(MPP_RETURN_ERROR);
						}	
						return(MPP_RETRY_NO_DEC);
					}
						
					MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 36, "Synch IO: Not ready & Not becoming ready\n")); 
					return(MPP_RETURN_ERROR);
					
				case SENSE_KEY_ILLEGAL_REQUEST:
					MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_1, "mpp_AnalyseSyncError: Illegal Request ASC/ASCQ 0x%x/0x%x\n", 
					SenseData->ASC, SenseData->ASCQ));

					MPP_ERRORLOGPRINT((MPP_ERR_ALL, 37, "Synch IO: Illegal Request\n")); 
					return(MPP_RETURN_ERROR);

				case SENSE_KEY_UNIT_ATTENTION:
					MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_1, 
					"mpp_AnalyseSyncError: UA ASC/ASCQ 0x%x/0x%x\n", 
					SenseData->ASC, SenseData->ASCQ));
					if( (SenseLengthReturned > 12) &&
					    (SenseData->ASC == ASC_QUIESCENCE) && (SenseData->ASCQ == ASCQ_QUIESCENCE_IN_PRGS) ) {
					    	if( (CurrentTime - StartTime) > mpp_QuiescenceWaitTime ) {
							MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 38, "Synch IO: Quiescence Wait Time exceeded\n")); 
							return(MPP_RETURN_ERROR);
						}
						return(MPP_RETRY_NO_DEC);
					}
					if( SenseLengthReturned > 12) {
						MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 39, 
						"Synch IO: Ua, ASC/ASCQ 0x%x/0x%x, fru 0x%x\n",
						SenseData->ASC, SenseData->ASCQ, SenseData->Field_Replaceable_Unit)); 
					}

					*UaRetryCount += 1;

					if( *UaRetryCount <= mpp_UaRetryCount ) {
						return(MPP_RETRY_NO_DEC);
					}

					MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 40, "Synch IO: UA Retry count exhausted\n")); 
					return(MPP_RETURN_ERROR);

				case SENSE_KEY_HARDWARE_ERROR:
					if( SenseLengthReturned > 12) {
						MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 41, 
						"Synch IO: Hardware Error ASC/ASCQ 0x%x/0x%x, fru 0x%x\n",
						SenseData->ASC, SenseData->ASCQ, SenseData->Field_Replaceable_Unit)); 
					}
					return(MPP_RETURN_ERROR);
				default:
					MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 42, "Synch IO: Unrecognized SK - %d\n",
					SenseData->Sense_Key)); 
					return(MPP_RETURN_ERROR);
			}	
		 
		case MPP_SCSI_BUSY:
			if( (CurrentTime - StartTime) > mpp_BusyWaitTime ) {
				MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 43, "Synch IO: Busy Wait Time exceeded\n")); 
				return(MPP_RETURN_ERROR);
			}
			
			return(MPP_RETRY_NO_DEC);
		 
		case MPP_SELECTION_TIMEOUT:
			*SelectionTimeoutRetryCount += 1;
			if( *SelectionTimeoutRetryCount <= mpp_SelectionTimeoutRetryCount ) {
				MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 44, "Synch IO: Retrying Selection Timeout\n")); 
				return(MPP_RETRY_NO_DEC);
			}
			// 07/30/03 - Changed error level from FATAL to RECOVERED to reduce the
			// number of error messages produced when the scan task process tries to
			// talk with devices currently marked as failed.
			MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 45, "Synch IO: Selection Retry count exhausted\n")); 
			return(MPP_RETURN_ERROR); 

		case MPP_SCSI_RESERVATION:
			// 02/20/03 - Changed error level from FATAL to RECOVERED to reduce the
			// number of error messages produced when MSCS is used.
			MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 46, "Synch IO: Reservation Conflict\n")); 
			return(MPP_RETURN_ERROR); 
		case MPP_INVALID_REQUEST: 
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 47, "Synch IO: Illegal Command\n")); 
			return(MPP_RETURN_ERROR);

		case MPP_COMMAND_TIMEOUT: 
			*CommandTimeoutRetryCount += 1;
			 if( *CommandTimeoutRetryCount <= mpp_CommandTimeoutRetryCount ) {
				MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 109, "Synch IO: Retrying command Timeout\n")); 
				return(MPP_RETRY_NO_DEC);
			 }

			 MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 48, "Synch IO: Command Timeout Retry count exhausted\n")); 
			 return(MPP_RETURN_ERROR);

		case MPP_UNSUPPORTED_SCSI_STATUS: 
		case MPP_HARDWARE_ERROR: 
		case MPP_COMMAND_ABORTED: 
		case MPP_UNRECOGNIZED_OS_STATUS: 
		case MPP_REQUEST_SENSE_FAILED:
		default:
			MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 49, "Synch IO: Retrying mpp status %d\n", mppStatus)); 
			return(MPP_RETRY_DEC_COUNT);
	}
}

/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_SynchronousIo
* SUMMARY:  
* SCOPE:    private 
*
*
* DESCRIPTION: This routine is used by the MPP driver to initiate synchronous I/O.
*
* RESTRICTIONS: 
* 
* RETURNS: 
*
* ERRNO: 
*
* NOTES:
*
* EXAMPLES:  					 
*
* SEE ALSO: 
*
*/
LWORD 
mpp_SynchronousIo(MPP_HANDLE DeviceVertex, BYTE *cdb, BYTE cdblen, void *BufferAddress, LWORD BufferLength, TINY Direction)
{
	SenseData_t *SenseData;
	LWORD SenseLengthReturned, DataLengthXfered, mppStatus, retry;
	LWORD retryCount;
	MPP_TIME StartTime;
	LWORD SelectionTimeoutRetryCount = 0;
	LWORD CommandTimeoutRetryCount = 0;
	LWORD UaRetryCount = 0;
	
	MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG, "mpp_SynchronousIo:  called with vertex 0x%x, cdb 0x%lx, cdblen %d, BufferAddress 0x%lx, BufferLength 0x%x\n",
	DeviceVertex, cdb, cdblen, BufferAddress, BufferLength));
	SenseData = (SenseData_t *) MPP_INT_KMEM_ALLOC(sizeof(SenseData_t));
	if( !SenseData ) {
		MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 103, "Unable to allocate memory\n")); 
		return(FALSE);
	}	
	MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_SynchronousIo: SenseData 0x%lx\n", SenseData));
	MPP_GETTIME(StartTime); 
	MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_4, "mpp_SynchronousIo: StartTime 0x%lx\n", StartTime));

	for( retryCount = mpp_SyncRetryCount; retryCount > 0;  ) {
    		MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_SynchronousIo: calling mpp_SysdepSynchronousIo, vertex 0x%lx, retryCount %d\n",
		DeviceVertex, retryCount));
		mppStatus = mpp_SysdepSynchronousIo(DeviceVertex, cdb, cdblen, BufferAddress, BufferLength, SenseData, sizeof(SenseData_t), 
				Direction, &SenseLengthReturned, &DataLengthXfered);

    		MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_SynchronousIo: mpp_SysdepSynchronousIo returned status %d\n", mppStatus));
		if(mppStatus != MPP_GOOD_STATUS)
		{
		        retry = mpp_AnalyseSyncError(mppStatus, SenseData, SenseLengthReturned, DataLengthXfered, 
			        StartTime, &SelectionTimeoutRetryCount, &CommandTimeoutRetryCount, &UaRetryCount );
		}
		else
		{
			retry = MPP_NO_ERROR;
		}

		if( (retry == MPP_NO_ERROR) || (retry == MPP_RETURN_ERROR) ) {
			MPP_FREE(SenseData, sizeof(SenseData_t));
			return(retry);
		}
		if( retry == MPP_RETRY_DEC_COUNT )
			--retryCount;
	}
	MPP_FREE(SenseData, sizeof(SenseData_t));
	return(MPP_RETURN_ERROR);
	
}


/*******************************************************************************
* PROCEDURE
*
* NAME:     mpp_SynchInquiry
* SUMMARY:  
* SCOPE:    private 
*
*
* DESCRIPTION: This routine is used by the MPP driver to initiate synchronous Inquiry commands.
*
* RESTRICTIONS: 
* 
* RETURNS: 
*
* ERRNO: 
*
* NOTES:
*
* EXAMPLES:  					 
*
* SEE ALSO: 
*
*/
LWORD 
mpp_SynchInquiry(MPP_HANDLE DeviceVertex, BOOL Evpd, BYTE PgCode, void *BufferAddress, LWORD BufferLength)
{
	LWORD	status;
	BYTE	*cdb, cdblen=6, i, j, *buffer;
	CHAR	output[38];
	
	MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG, "mpp_SynchInquiry:  called with vertex 0x%x, Evpd %d, PgCode 0x%x, BufferAddress 0x%lx, BufferLength 0x%x\n",
	DeviceVertex, Evpd, PgCode, BufferAddress, BufferLength));
	cdb = (BYTE *) MPP_INT_KMEM_ALLOC(6);
	if( !cdb ) {
		MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 102, "Unable to allocate memory\n")); 
		return(FALSE);
	}
	*cdb = 0x12;
	*(cdb+1) = (BYTE) Evpd;
	*(cdb+2) = PgCode;
	*(cdb+3) = *(cdb+5) = 0;
	*(cdb+4) = (BYTE) BufferLength;
	bzero(BufferAddress, BufferLength);
	bzero(output, 38);

	status = mpp_SynchronousIo(DeviceVertex, cdb, cdblen, BufferAddress, BufferLength, 1);
	MPP_FREE(cdb, 6);
	if( !status ) {
		buffer = (BYTE *) BufferAddress;
    		MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_4, "mpp_SynchInquiry: data returned\n"));

		// 09/01/02 - Replaced output algorithm with this one, which causes the Driver Verifier utility under
		// Windows W2K/.NET to crash the system due to invalid regions of memory being printed.
		for(i=0, j=0; i<BufferLength; ++i)
		{
			if((i != 0) && !(i % 12))
			{
    				MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_4, "%s\n", output));
				bzero(output, 38);
				j = 0;
			}

			sprintf(&output[j*3], "%02x ", *(buffer+i));
			j++;
		}

    		MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_4, "%s\n", output));
	}
	return(status);
}

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_GetAVTData
* SUMMARY:  
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function sends an VPD page inquiry for page 0xC9 and returns the AVT data.   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means AVT Data was returned.
*************************************************************************/
 
LWORD 
mpp_GetAVTData(MPP_HANDLE DeviceVertex, BYTE *AVTPriority, BOOL *CurrentOwner, BOOL *AVTEnabled)
{
	InqVolumeAccessControl_t *VolumeAccessControlPage;


	VolumeAccessControlPage = (InqVolumeAccessControl_t *) MPP_INT_KMEM_ALLOC(sizeof(InqVolumeAccessControl_t));
	if( !VolumeAccessControlPage ) {
		MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 100, "Unable to allocate memory\n")); 
		return(FALSE);
	}
	if( !mpp_SynchInquiry(DeviceVertex, TRUE, INQ_VOLACESSCTRL_PAGE, VolumeAccessControlPage, sizeof(InqVolumeAccessControl_t)) ) {
		*AVTEnabled = VolumeAccessControlPage->AVTCVP>>7;		
		*CurrentOwner = VolumeAccessControlPage->AVTCVP & 0x1;
		*AVTPriority = VolumeAccessControlPage->PathPriotity&0xf;		
		MPP_FREE(VolumeAccessControlPage, sizeof(InqVolumeAccessControl_t));
		return(TRUE);
	}
	
	MPP_FREE(VolumeAccessControlPage, sizeof(InqVolumeAccessControl_t));
	return(FALSE);
}


/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_GetUTMData
* SUMMARY:  
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function sends an VPD page inquiry for page 0xC3 and returns the UTM data.   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means UTM Data was returned.
*************************************************************************/
 
LWORD 
mpp_GetUTMData(MPP_HANDLE DeviceVertex, BYTE *UTMLun, BOOL *UTMEnabled)
{
	InqFeaParData_t *FeatureParametersPage;


	FeatureParametersPage = (InqFeaParData_t *) MPP_KMEM_ALLOC(sizeof(InqFeaParData_t));
	if( !mpp_SynchInquiry(DeviceVertex, TRUE, INQ_FEAPAR_PAGE, FeatureParametersPage, sizeof(InqFeaParData_t)) ) {
		*UTMEnabled = FeatureParametersPage->UTMData>>7;		
		*UTMLun = FeatureParametersPage->UTMData & 0x7f;		
		MPP_FREE(FeatureParametersPage, sizeof(InqFeaParData_t));
		return(TRUE);
	}
	
	MPP_FREE(FeatureParametersPage, sizeof(InqFeaParData_t));
	return(FALSE);
}


/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_GetArrayName
* SUMMARY:  
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function sends an VPD page inquiry for page 0xC8 and returns the Array WWN & ASCII name.   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means the Array names were returned.
*************************************************************************/
 
LWORD 
mpp_GetArrayName(MPP_HANDLE DeviceVertex, BYTE *ArrayWWN, BYTE *ArrayAsciiName, BYTE *Lun)
{
	InqExtDeviceId_t	*ExtDeviceIdPage;
	MPP_TIME		CurrentTime, StartTime;
	LWORD			i;

	ExtDeviceIdPage = (InqExtDeviceId_t *) MPP_KMEM_ALLOC(sizeof(InqExtDeviceId_t));


	/** 10/03/02 - During W2K/.NET testing it was discovered that the Extended Device Id inquiry
	    request was issued to a volume before the controller has a chance to populate the Storage
	    Array WWN.  This can result in MPP thinking a different array exists.  Although the
	    controller firmware could be changed to populate the field earlier in SOD the timing
	    window may still exist.  As a result, code is added here to retry the inquiry request
	    at periodic intervals until some limit is reached. **/
	MPP_GETTIME(StartTime);
	MPP_GETTIME(CurrentTime);

	while(TRUE)
	{
		if((CurrentTime - StartTime) > mpp_InquiryWaitTime)
		{
			MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3,
				"mpp_GetArrayName: Exceeded Inquiry Wait Time\n"));
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 110, "GetArrayName Inquiry Wait Time exceeded\n")); 
			break;
		}

		bzero(ExtDeviceIdPage, sizeof(InqExtDeviceId_t));
		if(!mpp_SynchInquiry(DeviceVertex, TRUE, INQ_EXTDEVID_PAGE, ExtDeviceIdPage, sizeof(InqExtDeviceId_t)))
		{
			if(!(mpp_IsNull(ExtDeviceIdPage->ArrayUniqueId, 16) || mpp_IsBlank(ExtDeviceIdPage->ArrayUniqueId, 16)))
			{
				bcopy(&ExtDeviceIdPage->ArrayUniqueId, ArrayWWN, 16);
				for(i=0; i<30; ++i)
            {
					*(ArrayAsciiName+i) = ExtDeviceIdPage->ArrayUserLabel[(2*i)+1];
               /*
               * replace characters that are not legal as Unix file name
               * # 0x23
               * - 0x2d
               * . 0x2E
               * 0-9 0x30 - 0x39
               * A-Z 0x41 - 0x5A
               * _  0x5F
               * a-z 0x61 - 0x7A
               * 
               */
               if(*(ArrayAsciiName+i) == 0||
                  *(ArrayAsciiName+i) == 0x23 || 
                  *(ArrayAsciiName+i) == 0x2d ||
                  *(ArrayAsciiName+i) == 0x2e ||
                  ((*(ArrayAsciiName+i) >= 0x30) && (*(ArrayAsciiName+i) <=0x39)) ||
                  ((*(ArrayAsciiName+i) >= 0x41) && (*(ArrayAsciiName+i) <=0x5a)) ||
                  *(ArrayAsciiName+i) == 0x5f ||
                  ((*(ArrayAsciiName+i) >= 0x61) && (*(ArrayAsciiName+i) <= 0x7a)) )
               {
                  /*
                  * no op
                  */
                  ;
               }
               else
               {
                  *(ArrayAsciiName+i)=0x5f;/* replace it with "_"*/
               }
            }

				*Lun = ExtDeviceIdPage->LogicalUnitNumber[7];		
				MPP_FREE(ExtDeviceIdPage, sizeof(InqExtDeviceId_t));
				return(TRUE);
			}
		}
		else
		{
			MPP_FREE(ExtDeviceIdPage, sizeof(InqExtDeviceId_t));
			return(FALSE);
		}

		mpp_ThreadDelay(mpp_InquiryInterval, MPPCMN_DELAY_SECONDS);
		MPP_GETTIME(CurrentTime);
	}

	MPP_FREE(ExtDeviceIdPage, sizeof(InqExtDeviceId_t));
	return(FALSE);
}


LWORD
mpp_GetMaxLunsSupported(MPP_HANDLE DeviceVertex, BYTE *MaxLuns)
{
	InqSwPageData_t *SwPage;

	SwPage = (InqSwPageData_t *) MPP_INT_KMEM_ALLOC(sizeof(InqSwPageData_t));
	if( !SwPage ) {
		MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 101, "Unable to allocate memory\n")); 
		return(FALSE);
	}

	if( mpp_SynchInquiry(DeviceVertex, TRUE, INQ_SFWVER_PAGE, SwPage, sizeof(InqSwPageData_t)) ) {
		MPP_FREE(SwPage, sizeof(InqSwPageData_t));
		return(FALSE);
	}

	*MaxLuns = SwPage->Max_LUN_Supported[0];
	MPP_FREE(SwPage, sizeof(InqSwPageData_t));
	return(TRUE);
}						     

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_IsNull
* SUMMARY:  
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function determines whether a given buffer is entirely null.
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means the buffer is entirely null.
*************************************************************************/
LWORD
mpp_IsNull(BYTE *BufferAddress, LWORD BufferLength)
{
	LWORD		cnt;

	for(cnt = 0; cnt < BufferLength; cnt++)
	{
		if(BufferAddress[cnt] != '\0')
			return(FALSE);
	}

	return(TRUE);

}


/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_IsBlank
* SUMMARY:  
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function determines whether a given buffer is entirely filled with
*   space characters.
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means the buffer is filled with blanks.
*************************************************************************/
LWORD
mpp_IsBlank(BYTE *BufferAddress, LWORD BufferLength)
{
	LWORD		cnt;

	for(cnt = 0; cnt < BufferLength; cnt++)
	{
		if(BufferAddress[cnt] != ' ')
			return(FALSE);
	}

	return(TRUE);

}


/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_GetVolumeWWN
* SUMMARY:  
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function sends an VPD page inquiry for page 0x83 and returns the Volume WWN.   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means Volume WWN was returned.
*************************************************************************/
 
LWORD 
mpp_GetVolumeWWN(MPP_HANDLE DeviceVertex, BYTE *VolumeWWN)
{
	InqDeviceIdData_t 	*DeviceIdPage;
	MPP_TIME		CurrentTime, StartTime;

	DeviceIdPage = (InqDeviceIdData_t *) MPP_KMEM_ALLOC(sizeof(InqDeviceIdData_t));

	MPP_GETTIME(StartTime);
	MPP_GETTIME(CurrentTime);

	while(TRUE)
	{
		if((CurrentTime - StartTime) > mpp_InquiryWaitTime)
		{
			MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3,
				"mpp_GetVolumeWWN: Exceeded Inquiry Wait Time\n"));
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 108, "GetVolumeWWN Inquiry Wait Time exceeded\n")); 
			break;
		}

		bzero(DeviceIdPage, sizeof(InqDeviceIdData_t));
		if(!mpp_SynchInquiry(DeviceVertex, TRUE, INQ_DEVCID_PAGE, DeviceIdPage, sizeof(InqDeviceIdData_t)))
		{
			if(!(mpp_IsNull(DeviceIdPage->ExtendedIdentifier, 16) || mpp_IsBlank(DeviceIdPage->ExtendedIdentifier, 16)))
			{
				bcopy(&DeviceIdPage->ExtendedIdentifier, VolumeWWN, 16);		
				MPP_FREE(DeviceIdPage, sizeof(InqDeviceIdData_t));
				return(TRUE);
			}
		}
		else
		{
			MPP_FREE(DeviceIdPage, sizeof(InqDeviceIdData_t));
			return(FALSE);
		}
	
		mpp_ThreadDelay(mpp_InquiryInterval, MPPCMN_DELAY_SECONDS);
		MPP_GETTIME(CurrentTime);
	}

	MPP_FREE(DeviceIdPage, sizeof(InqDeviceIdData_t));
	return(FALSE);
}

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_ControllerSlot
* SUMMARY:  
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function sends an VPD page inquiry for page 0xC4 and returns the Controller slot A/B   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means Controller Slot was returned.
*************************************************************************/
 
LWORD 
mpp_ControllerSlot(MPP_HANDLE DeviceVertex, BYTE *Slot)
{
	InqSubSystem_t *SubSystemPage;

	SubSystemPage = (InqSubSystem_t *) MPP_KMEM_ALLOC(sizeof(InqSubSystem_t));
	if( !mpp_SynchInquiry(DeviceVertex, TRUE, INQ_SUBSYS_PAGE, SubSystemPage, sizeof(InqSubSystem_t)) ) {
		if( SubSystemPage->ControllerSlotId[1] == 0x31 ) 
			*Slot = 0;
		else {
			if( SubSystemPage->ControllerSlotId[1] == 0x32 )
				*Slot = 1;
			else {
				MPP_FREE(SubSystemPage, sizeof(InqSubSystem_t));
				return(FALSE);
			}
		}		
		MPP_FREE(SubSystemPage, sizeof(InqSubSystem_t));
		return(TRUE);
	}
	
	MPP_FREE(SubSystemPage, sizeof(InqSubSystem_t));
	return(FALSE);
}
/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_CheckHwVersion
* SUMMARY:  Check the Hardware Version VPD page, 0xC0
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function sends an VPD page inquiry for page 0xC0 and checks the Page Identifier.   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means the page identifier matches an LSI array.
*************************************************************************/
 
LWORD 
mpp_CheckHwVersion(MPP_HANDLE DeviceVertex)
{
	InqHwPageData_t *HwPage;


	HwPage = (InqHwPageData_t *) MPP_KMEM_ALLOC(sizeof(InqHwPageData_t));
	if( mpp_SynchInquiry(DeviceVertex, TRUE, INQ_HDWVER_PAGE, HwPage, sizeof(InqHwPageData_t)) ) {
		MPP_FREE(HwPage, sizeof(InqHwPageData_t));
		return(FALSE);
	}

	if( (HwPage->Page_Identifier[0] == mpp_HardwareStamp[0]) &&
	    (HwPage->Page_Identifier[1] == mpp_HardwareStamp[1]) &&
	    (HwPage->Page_Identifier[2] == mpp_HardwareStamp[2]) &&
	    (HwPage->Page_Identifier[3] == mpp_HardwareStamp[3]) ) {
		MPP_FREE(HwPage, sizeof(InqHwPageData_t));
		return(TRUE);
	}
	
	MPP_FREE(HwPage, sizeof(InqHwPageData_t));
	return(FALSE);
}

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_CheckFwVersion
* SUMMARY:  Check the Firmware Version VPD page, 0xC1
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function sends an VPD page inquiry for page 0xC1 and checks the Page Identifier.   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means the page identifier matches an LSI array.
*************************************************************************/
 
LWORD 
mpp_CheckFwVersion(MPP_HANDLE DeviceVertex)
{
	InqFwPageData_t *FwPage;


	FwPage = (InqFwPageData_t *) MPP_KMEM_ALLOC(sizeof(InqFwPageData_t));
	if( mpp_SynchInquiry(DeviceVertex, TRUE, INQ_FRMVER_PAGE, FwPage, sizeof(InqFwPageData_t)) ) {
		MPP_FREE(FwPage, sizeof(InqFwPageData_t));
		return(FALSE);
	}

	if( (FwPage->Page_Identifier[0] == mpp_FirmwareStamp[0]) &&
	    (FwPage->Page_Identifier[1] == mpp_FirmwareStamp[1]) &&
	    (FwPage->Page_Identifier[2] == mpp_FirmwareStamp[2]) &&
	    (FwPage->Page_Identifier[3] == mpp_FirmwareStamp[3]) ) {
		MPP_FREE(FwPage, sizeof(InqFwPageData_t));
		return(TRUE);
	}
	MPP_FREE(FwPage, sizeof(InqFwPageData_t));
	return(FALSE);
}
/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_CheckSwVersion
* SUMMARY:  Check the Software Version VPD page, 0xC2
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function sends an VPD page inquiry for page 0xC2 and checks the Page Identifier.   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means the page identifier matches an LSI array.
*************************************************************************/
 
LWORD 
mpp_CheckSwVersion(MPP_HANDLE DeviceVertex, BYTE *FirmwareVersion)
{
	InqSwPageData_t *SwPage;


	SwPage = (InqSwPageData_t *) MPP_INT_KMEM_ALLOC(sizeof(InqSwPageData_t));
	if( !SwPage ) {
		MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 101, "Unable to allocate memory\n")); 
		return(FALSE);
	}
	if( mpp_SynchInquiry(DeviceVertex, TRUE, INQ_SFWVER_PAGE, SwPage, sizeof(InqSwPageData_t)) ) {
		MPP_FREE(SwPage, sizeof(InqSwPageData_t));
		return(FALSE);
	}

	if( (SwPage->Page_Identifier[0] == mpp_SoftwareStamp[0]) &&
	    (SwPage->Page_Identifier[1] == mpp_SoftwareStamp[1]) &&
	    (SwPage->Page_Identifier[2] == mpp_SoftwareStamp[2]) &&
	    (SwPage->Page_Identifier[3] == mpp_SoftwareStamp[3]) &&
	    mpp_IsSupported(FeatMinimumFirmwareRelease, SwPage->SW_Version))
	{
		bcopy(&SwPage->SW_Version, FirmwareVersion, 3);
		
		MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_3,
			"mpp_CheckSwVersion:  SoftWare Version %x.%x.%x\n", 
			FirmwareVersion[0], FirmwareVersion[1], FirmwareVersion[2]));
		MPP_FREE(SwPage, sizeof(InqSwPageData_t));
		return(TRUE);
	}
	
	MPP_FREE(SwPage, sizeof(InqSwPageData_t));
	return(FALSE);
}						     


LWORD
mpp_IsSupported(MPP_FEATURE_ID Feature, BYTE *SwVersion)
{
	BYTE		count;

	for(count = 0; count < MAX_FEATURE_SUPPORT; count++)
	{
		if(mpp_FeatureSupport[count].FeatureId != Feature)
			continue;

		if(SwVersion[0] >= mpp_FeatureSupport[count].MajorRelease ||
		  (SwVersion[0] == mpp_FeatureSupport[count].MajorRelease &&
		   SwVersion[1] >= mpp_FeatureSupport[count].MinorRelease))
			return(TRUE);
	}

	return(FALSE);
}


/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_IsArray
* SUMMARY:  Determine if candidate is a disk array LUN
* SCOPE:    local
*
*
* DESCRIPTION:
*   This function sends VPD page inquiries to determine if the device belongs to a
*   disk array.  It looks for signatures in the hardware, firmware and
*   software version pages.   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE means this is an array.
*   If lunAvailable is TRUE, then this particular LUN does exist.
*************************************************************************/
 
LWORD 
mpp_IsArray(MPP_HANDLE DeviceVertex, BYTE *FirmwareVersion)
{
	LWORD pageCount;
	LWORD i, found;
      	InqSupportedPages_t	*supPages;
	
	MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG, "mpp_IsArray:  called with vertex 0x%x\n", DeviceVertex));
	supPages = (InqSupportedPages_t *) MPP_KMEM_ALLOC(sizeof(InqSupportedPages_t));
	if( mpp_SynchInquiry(DeviceVertex, TRUE, 0, supPages, sizeof(InqSupportedPages_t)) ) {
		MPP_FREE(supPages, sizeof(InqSupportedPages_t));
		return(FALSE);
	}

	pageCount = supPages->PageLength;
	if( pageCount > sizeof(supPages->Pages) )
      		pageCount = sizeof(supPages->Pages);

	found = 0; 
	for ( i = 0; i < pageCount ; i++)
	{
		if (supPages->Pages[i] == INQ_HDWVER_PAGE)
		{
	    		if ( ( ((WORD) (i + 2)) < pageCount-2) &&
				  (supPages->Pages[i+1] == INQ_FRMVER_PAGE) &&
				  (supPages->Pages[i+2] == INQ_SFWVER_PAGE) )
			{
				found = 1;
				break;
			} else {
				MPP_FREE(supPages, sizeof(InqSupportedPages_t));
				return(FALSE);
			}
		}

	}

	MPP_FREE(supPages, sizeof(InqSupportedPages_t));
	if(!found)
	{
		MPP_DEBUGPRINT((MPP_SYNC_IO_DEBUG+MPP_DEBUG_LEVEL_1, "mpp_IsArray:  VPD pages not found\n"));
		return(FALSE);
	}


	if( mpp_CheckHwVersion(DeviceVertex) &&
	    mpp_CheckFwVersion(DeviceVertex) &&
	    mpp_CheckSwVersion(DeviceVertex, &FirmwareVersion[0]) ) {
		return (TRUE);
	}

	return (FALSE);
}

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_MatchExistingController
* SUMMARY:  Search the array of modules for an entry with a matching controller 
*	    but this is a new path
* SCOPE:    local
*
*
* DESCRIPTION:
   
*
* RESTRICTIONS:
*
* RETURNS:
*   RdacInfo or NULL
*************************************************************************/
RdacDeviceInformation_t *
mpp_MatchExistingController(BYTE *ArrayWWN, BYTE ControllerIndex, 
			BYTE *PathIndex)
{
	BYTE i, Path;
	RdacDeviceInformation_t *RdacInfo;
	ArrayModuleEntry_t *ModPtr;

	ModPtr = mpp_ModuleArray;
	for(i=0; i<mpp_MaxArrayModules; ++i){
		if( (RdacInfo = ModPtr->RdacInfo) ) {
			if( !bcmp( (BYTE *) &RdacInfo->WWN, ArrayWWN, 16) ) {
				if( RdacInfo->ControllerInfo[ControllerIndex]->ControllerPresent ) {
					for(Path=0; Path<mpp_MaxPathsPerController; ++Path) {
						if( !RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[Path].Present ) {
							*PathIndex = Path;
							MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, 
							"mpp_MatchExistingController: %s:%d:%d\n",
							RdacInfo->ModuleName, ControllerIndex, Path));
							return(RdacInfo);
						}
					}
					MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 50, "MaxPathsPerController (%d) exceeded for %s:%d\n",
					mpp_MaxPathsPerController, ModPtr->ModuleName, ControllerIndex));
					*PathIndex = 0xff;
					return(RdacInfo); 
				}
				*PathIndex = 0;
				return(RdacInfo);
			}	
		}
		++ModPtr;
	}
	return(NULL);
}

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_SelectPath
* SUMMARY:  Select the correct path for an I/O to a Lun
* RETURNS:
*   MPP_HANDLE or NULL.
*************************************************************************/ 
MPP_HANDLE 
mpp_SelectPath(RdacDeviceInformation_t *RdacInfo, BYTE Lun, BYTE *Controller, BYTE *Path)
{
	LWORD ControllerIndex, PathIndex;	
	BYTE paths_checked;
	MPP_HANDLE PathVertex=NULL;
	LINT LockLevel;
	MPP_HANDLE PathDeviceObject;

	
    	MPP_LOCK(RdacInfo->Lock, LockLevel);
	
	ControllerIndex = RdacInfo->RdacLuns[Lun].CurrentOwningPath;

	if( mppSys_AreControllerPathsFailed(RdacInfo, (BYTE)ControllerIndex, Lun) ||
		RdacInfo->ControllerInfo[ControllerIndex]->Failed ||
		!RdacInfo->ControllerInfo[ControllerIndex]->ControllerPresent)
	{
		ControllerIndex ^= 1;
		RdacInfo->RdacLuns[Lun].CurrentOwningPath = ControllerIndex;
	}
	
	/**
	 ** 05/21/01 - Preferred controller path changes for SCSI reservation/release commands.
	 **/
	if(RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->PreferredControllerPath > -1)
	{
		PathIndex = RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->PreferredControllerPath;
		MPP_DEBUGPRINT((MPP_HBA_COMMAND_DEBUG+MPP_DEBUG_LEVEL_4, 
			"mpp_SelectPath: %s:%d PreferredControllerPath = %d\n", 
			RdacInfo->ModuleName, ControllerIndex, PathIndex));

		PathDeviceObject=NULL;

		if( RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[PathIndex].Present &&
			!RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[PathIndex].Failed &&
			!RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].PathRemoveState)
		{
			MPP_DEBUGPRINT((MPP_HBA_COMMAND_DEBUG+MPP_DEBUG_LEVEL_4, 
				"mpp_SelectPath: %s:%d:%d PreferredControllerPath %d\n",
				RdacInfo->ModuleName, ControllerIndex, Lun, PathIndex));
			PathDeviceObject = RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].LunPathDevice;
			
			if(!RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].PathRemoveState)
			{
				MPP_UNLOCK(RdacInfo->Lock, LockLevel);
				return(PathDeviceObject); 
			}
		}

		/**
		 ** We've lost the preferred controller path.  Return a NULL PathDeviceObject to indicate a controller
		 ** failover.
		 **/
		MPP_DEBUGPRINT((MPP_HBA_COMMAND_DEBUG+MPP_DEBUG_LEVEL_4, 
			"mpp_SelectPath: %s:%d:%d PreferredControllerPath %d not available\n",
			RdacInfo->ModuleName, ControllerIndex, Lun, PathIndex));
			MPP_UNLOCK(RdacInfo->Lock, LockLevel);
		return(PathDeviceObject); 
	}

	for( paths_checked = 0;  paths_checked <mpp_MaxPathsPerController; ++paths_checked ) { 
		PathIndex = RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->RoundRobinPathIndex;
		MPP_DEBUGPRINT((MPP_HBA_COMMAND_DEBUG+MPP_DEBUG_LEVEL_4, "mpp_SelectPath: testing %s:%d:%d\n",
		RdacInfo->ModuleName, ControllerIndex, PathIndex));
		if( RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[PathIndex].Present &&
			!RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[PathIndex].Failed &&
			RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].LunPathDevice &&
			!RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].PathRemoveState) 
		{
			PathVertex = RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].LunPathDevice;
			*Controller = (BYTE) ControllerIndex;
			*Path = (BYTE) PathIndex;
			break;
		}
			
		++RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->RoundRobinPathIndex; 
		RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->RoundRobinPathIndex %= mpp_MaxPathsPerController; 
	}
	
	++RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->RoundRobinPathIndex; 
	RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->RoundRobinPathIndex %=  mpp_MaxPathsPerController;
	MPP_DEBUGPRINT((MPP_HBA_COMMAND_DEBUG+MPP_DEBUG_LEVEL_4,
		"mpp_SelectPath: %s:%d RoundRobinPathIndex %d DevObj 0x%x\n",
		RdacInfo->ModuleName, Lun,
		RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->RoundRobinPathIndex,
		PathVertex));
	MPP_UNLOCK(RdacInfo->Lock, LockLevel);	
	return(PathVertex);

}

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_SelectFailoverPath
* SUMMARY:  Select the correct path for an I/O to a Lun
* RETURNS:
*   MPP_HANDLE or NULL.
*************************************************************************/ 
MPP_HANDLE 
mpp_SelectFailoverPath(RdacDeviceInformation_t *RdacInfo, BYTE Lun, BYTE *Controller, BYTE *Path)
{
	BYTE ControllerIndex, PathIndex=*Path;	
	BYTE paths_checked;
	MPP_HANDLE PathVertex=NULL;
	LINT LockLevel;

	
    	MPP_LOCK(RdacInfo->Lock, LockLevel);
	
	ControllerIndex = *Controller;
	
		
	for( paths_checked = 0;  paths_checked <mpp_MaxPathsPerController; ++paths_checked ) { 
		++PathIndex;
		PathIndex %= mpp_MaxPathsPerController;
		if( RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[PathIndex].Present &&
		    !RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[PathIndex].Failed &&
		    RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].LunPathDevice &&
		    !RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].PathRemoveState ) {
			
		        PathVertex = RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].LunPathDevice;
			break;
		}
	}
	
	*Path = PathIndex;	

	MPP_UNLOCK(RdacInfo->Lock, LockLevel);	
	return(PathVertex);

}
/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_MatchExistingControllerPath
* SUMMARY:  Search the array of modules for an entry with a matching controller address
* SCOPE:    local
*
*
* DESCRIPTION:
   
*
* RESTRICTIONS:
*
* RETURNS:
*   RdacInfo or NULL.
*************************************************************************/
RdacDeviceInformation_t *
mpp_MatchExistingControllerPath(ControllerAddress_t *DeviceAddress, BYTE *ControllerIndex, BYTE *PathIndex)
{
	BYTE i, Controller, Path;
	RdacDeviceInformation_t *RdacInfo;
	ArrayModuleEntry_t *ModPtr;

	ModPtr = mpp_ModuleArray;
	/*MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, 
	"mpp_MatchExistingControllerPath: Attempting to match ControllerTrans 0x%lx, TargetId %d\n",
	DeviceAddress->ControllerTrans,
	DeviceAddress->TargetId));*/
	for(i=0; i<mpp_MaxArrayModules; ++i){
		if( (RdacInfo = ModPtr->RdacInfo) ) {
			for(Controller=0; Controller<2; ++Controller) {
				if( RdacInfo->ControllerInfo[Controller]->ControllerPresent ) {
					for(Path=0; Path<mpp_MaxPathsPerController; ++Path) {
						/*if( RdacInfo->ControllerInfo[Controller]->ControllerPath[Path].Present ) {
							MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, 
							"mpp_MatchExistingControllerPath: Path %s:%d:%d present, ControllerTrans 0x%lx, TargetId %d\n",
							RdacInfo->ModuleName, Controller, Path, 
							RdacInfo->ControllerInfo[Controller]->ControllerPath[Path].Address.ControllerTrans,
							RdacInfo->ControllerInfo[Controller]->ControllerPath[Path].Address.TargetId));
						}*/
						if( (RdacInfo->ControllerInfo[Controller]->ControllerPath[Path].Present) &&
						    (!bcmp( (BYTE *) &RdacInfo->ControllerInfo[Controller]->ControllerPath[Path].Address,
						            (BYTE *) DeviceAddress, sizeof(ControllerAddress_t)) ) ) {
							     *ControllerIndex = Controller;
							     *PathIndex	= Path;
							     MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, 
							     "mpp_MatchExistingControllerPath: %s:%d:%d\n",
							     RdacInfo->ModuleName, Controller, Path));
							     return(RdacInfo);
						}	
					}
				}
			}	
		}
		++ModPtr;
	}
	return(NULL);	
} 

/**************************************************************************************
* PROCEDURE
*
* NAME:     mpp_MaxArrayModuleOverflow
* SUMMARY:  Check to see if we find new ArrayModules greater than the configured MAXIMUM 
* SCOPE:    local
*
*
* DESCRIPTION:
*	Check all the slots in the ArrayModule datastructure for free slots.
*       If there is no free slot then return TRUE. Else return FALSE.
*
* RESTRICTIONS:
*
* RETURNS: 
*   TRUE or FALSE.  TRUE if there is no free slot for the newly identified array module.
****************************************************************************************/
BOOL
mpp_MaxArrayModuleOverflow(   BYTE *ArrayWWN, BYTE *ArrayAsciiName   )
{

	BYTE i, AvailableSlot;
	ArrayModuleEntry_t *ModPtr;
	LWORD DuplicateArrayFound = FALSE;
	
	AvailableSlot = 0xff;
	ModPtr = mpp_ModuleArray;

	for(i=0; i<mpp_MaxArrayModules; ++i)
	{
		// if we find a free slot and it has no persistent binding array name, use it.
		if((!ModPtr->RdacInfo) && (AvailableSlot == 0xff) && ModPtr->ModuleName[0] == 0)
		{
				AvailableSlot = i;
		}
		else if(ModPtr->ModuleName[0] != 0 && !strcmp((TINY *) ArrayAsciiName, (TINY *) &ModPtr->ModuleName))
		{
			if(ModPtr->RdacInfo && bcmp((BYTE *) &ModPtr->RdacInfo->WWN, ArrayWWN, 16))
			{
				DuplicateArrayFound = TRUE;
			}
			else
			{
				AvailableSlot = i; 
			}
		}
		++ModPtr;
	}

	if( AvailableSlot == 0xff ) {
		return(TRUE);  // Array module overflow 
	}
	else 
	{
		return(FALSE);
	}
	
} 

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_AllocRdacinfo
* SUMMARY:  Allocate and initialize an RdacInfo
* SCOPE:    local
*
*
* DESCRIPTION:
   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE completed successfully.
*************************************************************************/
 
RdacDeviceInformation_t *
mpp_AllocRdacinfo(MPP_HANDLE DeviceVertex, BYTE *ArrayWWN, BYTE *ArrayAsciiName)
{
	RdacDeviceInformation_t *RdacInfo;
	BYTE i, AvailableSlot;
	LWORD Lun;
	BYTE *ptr;
	ArrayModuleEntry_t *ModPtr;
	BYTE AVTPriority;
	BYTE MaxLuns;
	BOOL CurrentOwner, AVTEnabled;
	LWORD RdacInfoSize;
	LWORD DuplicateArrayFound = FALSE;
	BYTE AsciiWWN[33];

	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: RdacDeviceInformation_t size 0x%x\n",
	sizeof(RdacDeviceInformation_t) ));
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: RdacLunInformation_t size 0x%x\n",
	sizeof(RdacLunInformation_t) ));
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: RdacControllerInformation_t size 0x%x\n",
	sizeof(RdacControllerInformation_t) ));
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: RdacControllerPath_t size 0x%x\n",
	sizeof(RdacControllerPath_t) ));
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: LunPathObjects_t size 0x%x\n",
	sizeof(LunPathObjects_t) ));
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: LunPathInfo_t size 0x%x\n",
	sizeof(LunPathInfo_t) ));

	RdacInfoSize = MPP_RDACINFOSIZE( mpp_MaxLunsPerArray, mpp_MaxPathsPerController);

	RdacInfo = (RdacDeviceInformation_t *) MPP_KMEM_ALLOC(RdacInfoSize);

	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: RdacInfo 0x%lx allocated, size 0x%x\n",
	RdacInfo, RdacInfoSize));

	ptr = (BYTE *) RdacInfo;
       	ptr = ptr + sizeof(RdacDeviceInformation_t) +
		(sizeof(RdacLunInformation_t)* (mpp_MaxLunsPerArray-1));

	RdacInfo->ControllerInfo[0] = (RdacControllerInformation_t *) ptr;
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: ControllerInfo[0] 0x%lx\n",
	RdacInfo->ControllerInfo[0]));

	ptr = (ptr  + sizeof(RdacControllerInformation_t) +
		(sizeof(RdacControllerPath_t)*(mpp_MaxPathsPerController-1)) );
	RdacInfo->ControllerInfo[1] = (RdacControllerInformation_t *) ptr;
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: ControllerInfo[1] 0x%lx\n",
	RdacInfo->ControllerInfo[1]));

	ptr = ptr + sizeof(RdacControllerInformation_t) +
		(sizeof(RdacControllerPath_t)*(mpp_MaxPathsPerController-1));

	for(Lun=0; Lun<mpp_MaxLunsPerArray; ++Lun) {
		LunPathObjects_t *LunPathObj;

		LunPathObj = (LunPathObjects_t *) ptr;
		LunPathObj->PreferredControllerPath = -1;
		RdacInfo->RdacLuns[Lun].LunControllers[0] = LunPathObj;

		MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: Lun %d, LunController[0] 0x%lx\n",
		Lun, RdacInfo->RdacLuns[Lun].LunControllers[0]));

		ptr = ptr + sizeof(LunPathObjects_t) + (sizeof(LunPathInfo_t)*(mpp_MaxPathsPerController-1));
		LunPathObj = (LunPathObjects_t *) ptr;
		LunPathObj->PreferredControllerPath = -1;
		RdacInfo->RdacLuns[Lun].LunControllers[1] = LunPathObj;

		MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: Lun %d, LunController[1] 0x%lx\n",
		Lun, RdacInfo->RdacLuns[Lun].LunControllers[1]));

		ptr = ptr + sizeof(LunPathObjects_t) + (sizeof(LunPathInfo_t)*(mpp_MaxPathsPerController-1));
       	}

	bcopy(ArrayWWN, &RdacInfo->WWN, 16);

	AvailableSlot = 0xff;
	ModPtr = mpp_ModuleArray;

	for(i=0; i<mpp_MaxArrayModules; ++i)
	{
		// if we find a free slot and it has no persistent binding array name, use it.
		if((!ModPtr->RdacInfo) && (AvailableSlot == 0xff) && ModPtr->ModuleName[0] == 0)
		{
				AvailableSlot = i;
		}
		else if(ModPtr->ModuleName[0] != 0 && !strcmp((TINY *) ArrayAsciiName, (TINY *) &ModPtr->ModuleName))
		{
			if(ModPtr->RdacInfo && bcmp((BYTE *) &ModPtr->RdacInfo->WWN, ArrayWWN, 16))
			{
				DuplicateArrayFound = TRUE;
			}
			else
			{
				AvailableSlot = i;
			}
		}
		++ModPtr;
	}

	if( AvailableSlot == 0xff ) {
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 51, "Maximum number of Array modules exceeded\n",
		       RdacInfo->ModuleName));
		MPP_FREE(RdacInfo, RdacInfoSize);
		return(NULL);
	}
	ModPtr = mpp_ModuleArray;
	ModPtr += AvailableSlot;

	if( *ArrayAsciiName == 0 )
	{
		sprintf((TINY *) &ModPtr->ModuleName, "Array_Module_%d", AvailableSlot);
	}
	else
	{
		if(DuplicateArrayFound)
		{
			// Log an error message so the user knows the array was internally renamed.  We want this message
			// to be seen at all error levels so use ERR_FATAL.
			mpp_ConvertWWNtoAscii(&AsciiWWN[0], ArrayWWN);
			sprintf((TINY *) &ModPtr->ModuleName, "%s_%d", ArrayAsciiName, AvailableSlot);
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 113, "Duplicate array name found for WWN %s.  Internally renamed to %s.\n",  AsciiWWN, ModPtr->ModuleName));
		}
		else
		{
			strcpy((TINY *) &ModPtr->ModuleName, (TINY *) ArrayAsciiName);
		}
	}

	ModPtr->RdacInfo = RdacInfo;
	RdacInfo->ModuleName = &ModPtr->ModuleName;
	RdacInfo->VirtualTargetId = AvailableSlot;

	if( !(RdacInfo->ModuleHandle = mpp_makeVirtualTarget(AvailableSlot)) ) {
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 52, "mpp_makeVirtualTarget returned an error on %s\n",
		       RdacInfo->ModuleName));
		ModPtr->RdacInfo = (RdacDeviceInformation_t *) 0;
		MPP_FREE(RdacInfo, RdacInfoSize);
		return(NULL);
	}

	if( !(mpp_GetAVTData(DeviceVertex, &AVTPriority, &CurrentOwner, &AVTEnabled)) ) {
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 53, "mpp_GetAVTData returned an error on %s\n",
		       RdacInfo->ModuleName));
		ModPtr->RdacInfo = (RdacDeviceInformation_t *) 0;
		MPP_FREE(RdacInfo, RdacInfoSize);
		return(NULL);
	}

	// 12/02/02 - RRS. Moved determination of 32 vs 256 lun support to this function.  My original implementation
	// forgot to take into account that multiple arrays, each with different firmware versions could be present.
	// In addition, my original approach used the Software Version Page (0xC2) to determine the controller version.
	// A better method is to use the MaxLunsSupported field in this page.  Unfortunately we have to query the
	// 0xC2 page twice - once to determine whether the device belongs to us and once here to determine max Luns.
	// We could set a global variable and check it here but under multi-processor environments the flag's value
	// may change between the original call and here.  This involves the overhead of making one additional call
	// to the software page for each new array discovered.
	if( !(mpp_GetMaxLunsSupported(DeviceVertex, &MaxLuns)))
	{
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 111, "mpp_GetMaxLunsSupported returned an error on %s\n",
			RdacInfo->ModuleName));
		ModPtr->RdacInfo = (RdacDeviceInformation_t *) 0;
		MPP_FREE(RdacInfo, RdacInfoSize);
		return(NULL);
	}

	// Anything above 31 Luns must use the SubPage for 0x2C
	if(MaxLuns > 0x1f)
		RdacInfo->Page2CSubPage1 = 1;
	else
		RdacInfo->Page2CSubPage1 = 0;
		
	RdacInfo->AVTEnabled = AVTEnabled;
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_AllocRdacinfo: %s, AVTEnabled %d, VirtualTargetId %d\n",
		RdacInfo->ModuleName, RdacInfo->AVTEnabled, RdacInfo->VirtualTargetId));
	MPP_LOCK_INIT(RdacInfo->Lock);
	return(RdacInfo);
}


VOID
mpp_ConvertWWNtoAscii(BYTE *AsciiWWN, BYTE *ArrayWWN)
{
	LWORD		count;

	bzero(AsciiWWN, 33);
	for(count = 0; count < 16; count++)
		sprintf(&AsciiWWN[count*2], "%02x", ArrayWWN[count]);
}


/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_InsertController
* SUMMARY:  Fill in the controller information in an RdacInfo
* SCOPE:    local
*
*
* DESCRIPTION:
   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE completed successfully.
*************************************************************************/
 
LWORD 
mpp_InsertController(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex)
{
	BYTE			UTMLun;
	BYTE			i;
	BOOL			UTMEnabled;
	LINT			LockLevel;
	ArrayModuleEntry_t	*ModPtr;

	if( !mpp_GetUTMData(DeviceVertex, &UTMLun, &UTMEnabled) ) {
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 54, "mpp_GetUTMData returned an error on %s:%d\n",
		       RdacInfo->ModuleName, ControllerIndex));
		return(FALSE);
	}
	MPP_LOCK(RdacInfo->Lock, LockLevel);
	RdacInfo->ControllerInfo[ControllerIndex]->ControllerPresent = TRUE;	
	RdacInfo->ControllerInfo[ControllerIndex]->UTMLunExists = UTMEnabled;
	RdacInfo->ControllerInfo[ControllerIndex]->UTMLunNumber = UTMEnabled ? UTMLun : -1;

	RdacInfo->ControllerInfo[ControllerIndex]->ReservationPathIndex = 0;

	/**
	 ** 06/25/03 - Under Windows the PnP manager will cause MPP to clean up its data structure information for
	 ** a controller when it is no longer present (for example, due to a controller or cable pull).  If the 
	 ** controller re-appears the structures will be rebuilt but its possible this controller is the preferred
	 ** owner for some of the volumes in the array.  Given this we must set the ControllerRestored information in
	 ** the ModuleArray structure in order for the failback process to move the luns to their correct owner.
	 **/
	ModPtr = mpp_ModuleArray;
	for(i=0; i<mpp_MaxArrayModules; ++i, ++ModPtr) 
	{
		if(ModPtr->RdacInfo == RdacInfo)
		{
			ModPtr->ControllerRestored = TRUE;
		}
	}


	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_InsertController: %s:%d inserted, with UTM enabled %d, UTM Lun %d\n",
	RdacInfo->ModuleName, ControllerIndex, 
	RdacInfo->ControllerInfo[ControllerIndex]->UTMLunExists,
	RdacInfo->ControllerInfo[ControllerIndex]->UTMLunNumber));
	MPP_UNLOCK(RdacInfo->Lock, LockLevel);
	return(TRUE);
		
}

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_InsertControllerPath
* SUMMARY:  Fill in the controller path information in an RdacInfo
* SCOPE:    local
*
*
* DESCRIPTION:
   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE completed successfully.
*************************************************************************/
 
LWORD 
mpp_InsertControllerPath(RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex, 
				BYTE Path, ControllerAddress_t *DeviceAddress)
{
	MPP_DIR_HANDLE DirectoryVertex;

	bcopy(DeviceAddress, &RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[Path].Address, 
				sizeof(ControllerAddress_t));

	if( !(DirectoryVertex = mpp_CreateControllerVertex(RdacInfo, ControllerIndex, Path, DeviceAddress)) ) {
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 55, "mpp_CreateControllerVertex returned an error on %s:%d:%d\n",
		       RdacInfo->ModuleName, ControllerIndex, Path));
		return(FALSE);
	}

	RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[Path].DirectoryVertex = DirectoryVertex;
	RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[Path].DirectoryCreated = 	  	
	RdacInfo->ControllerInfo[ControllerIndex]->ControllerPath[Path].Present = TRUE;
	++RdacInfo->ControllerInfo[ControllerIndex]->NumberOfPaths;
	if( RdacInfo->ControllerInfo[0]->NumberOfPaths && RdacInfo->ControllerInfo[1]->NumberOfPaths )
		RdacInfo->SingleController = FALSE;
	else
		RdacInfo->SingleController = TRUE;
		
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_InsertControllerPath: %s:%d:%d inserted,\n",
	RdacInfo->ModuleName, ControllerIndex, Path));
	return(TRUE);	  	
}

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_InsertLun
* SUMMARY:  Fill in the Lun information in an RdacInfo
* SCOPE:    local
*
*
* DESCRIPTION:
   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE completed successfully.
*************************************************************************/
 
LWORD 
mpp_InsertLun(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex, BYTE Lun)
{
	BYTE AVTPriority;
	BOOL CurrentOwner, AVTEnabled;
	LWORD VirtualBusStatus;

	INITIALIZE_PSEUDO_STATE(&RdacInfo->RdacLuns[Lun]);

	if( !mpp_GetVolumeWWN(DeviceVertex, &RdacInfo->RdacLuns[Lun].WWN[0]) ) {
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 56, "mpp_GetVolumeWWN returned an error on %s:%d:%d\n",
		       RdacInfo->ModuleName, ControllerIndex, Lun));
		return(FALSE);
	}
	
	if( !mpp_GetAVTData(DeviceVertex, &AVTPriority, &CurrentOwner, &AVTEnabled) ) {
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 57, " mpp_GetAVTData returned an error on %s:%d:%d\n",
		       RdacInfo->ModuleName, ControllerIndex, Lun));
		return(FALSE);
	}
	
	if( CurrentOwner )
		RdacInfo->RdacLuns[Lun].CurrentOwningPath = RdacInfo->RdacLuns[Lun].BootOwningPath = ControllerIndex;
	else
		RdacInfo->RdacLuns[Lun].CurrentOwningPath = RdacInfo->RdacLuns[Lun].BootOwningPath = ControllerIndex^1;

	if( AVTPriority == 1 )
		RdacInfo->RdacLuns[Lun].PreferredPath = ControllerIndex;
	else
		RdacInfo->RdacLuns[Lun].PreferredPath = ControllerIndex^1;

	if( RdacInfo->ControllerInfo[ControllerIndex]->UTMLunNumber == Lun )
		RdacInfo->RdacLuns[Lun].UTMLun = TRUE;
	else {
		if( !RdacInfo->RdacLuns[Lun].PseudoLunObject ) {
			// 09/12/02 - Added DeviceVertex as an input parameter.  In addition, under
			// Windows the virtual bus may be disabled but this should _not_ prevent the
			// physical disk paths from being claimed by MPP.  Presumably the user will
			// enable the pseudo-bus at a later time.
			RdacInfo->RdacLuns[Lun].PseudoLunObject = mpp_makeVirtualLun(DeviceVertex, RdacInfo, Lun, &VirtualBusStatus);
			if(VirtualBusStatus == MPP_PSEUDO_BUS_DISABLED ||
				(VirtualBusStatus == MPP_PSEUDO_BUS_ENABLED && RdacInfo->RdacLuns[Lun].PseudoLunObject))
			{
				return(TRUE);
			}

			return(FALSE);
		}
	}
	
				
	SET_NEW_PSEUDO_STATE(&RdacInfo->RdacLuns[Lun], Started);
	RdacInfo->RdacLuns[Lun].Present = TRUE;
	RdacInfo->RdacLuns[Lun].ReportedPresent = TRUE;
	RdacInfo->RdacLuns[Lun].ReportedMissing = FALSE;
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_InsertLun: %s:%d inserted, CurrentOwningPath %d, PreferredPath %d, UTM %d\n",
	RdacInfo->ModuleName, Lun, RdacInfo->RdacLuns[Lun].CurrentOwningPath, RdacInfo->RdacLuns[Lun].PreferredPath,
	RdacInfo->RdacLuns[Lun].UTMLun));
	return(TRUE);
}

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_InsertLunPath
* SUMMARY:  Fill in the Lun Path information in an RdacInfo
* SCOPE:    local
*
*
* DESCRIPTION:
   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE completed successfully.
*************************************************************************/
 
LWORD 
mpp_InsertLunPath(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex, BYTE PathIndex, 
	BYTE Lun)
{
	BYTE ThisWWN[16];
	LINT LockLevel;
   LWORD CheckReservationStatus;

	if( !mpp_GetVolumeWWN(DeviceVertex, &ThisWWN[0]) ) {
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 58, "mpp_GetVolumeWWN returned an error on %s:%d:%d:%d\n",
		       RdacInfo->ModuleName, ControllerIndex, PathIndex, Lun));
		return(FALSE);
	}
	if( !RdacInfo->RdacLuns[Lun].UTMLun && bcmp(&ThisWWN, &RdacInfo->RdacLuns[Lun].WWN, 16) )	{
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 59, "Volume WWN for %s:%d:%d:%d does not match\n",
		RdacInfo->ModuleName, ControllerIndex, PathIndex, Lun));
		return(FALSE);
	}
    /*
   * check whether of not we need to make a persistent reservation registration
   * for the newly added path before we make it available for IOs
   */
   CheckReservationStatus = mppCmn_CheckPRRegistration(RdacInfo, DeviceVertex);
   if(CheckReservationStatus == MPPCMN_PRTN_RETURN_ERROR)
   {
      MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 119,
            "mpp_InsertLunPath: Device %s:%d:%d:%d - get error in checking PR registration\n",
            RdacInfo->ModuleName, ControllerIndex, PathIndex,Lun));
   }
   else
   {
      MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3,
         "mpp_InsertLunPath: Device %s:%d:%d:% - Checked PR registrationd\n",
         RdacInfo->ModuleName, ControllerIndex, PathIndex,Lun));
   }

	MPP_LOCK(RdacInfo->Lock, LockLevel);
	RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].LunPathDevice = DeviceVertex;
	++RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->NumberOfLunObjects;
	MPP_UNLOCK(RdacInfo->Lock, LockLevel);
	if( RdacInfo->RdacLuns[Lun].UTMLun ) {
		if( !(RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].UtmLunDevice = 
			mpp_CreateUtmDevice(DeviceVertex, RdacInfo, ControllerIndex, PathIndex, Lun)) ) {
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 60,"Unable to create UTM path for %s:%d:%d\n", 
			RdacInfo->ModuleName, ControllerIndex, PathIndex));
		}
	}

	mpp_CreateLunLink(DeviceVertex, RdacInfo, ControllerIndex, PathIndex, Lun); 

    	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_InsertLunPath: %s:%d:%d:%d inserted\n",
	RdacInfo->ModuleName, ControllerIndex, PathIndex, Lun));
	return(TRUE);
}
/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_BuildRdacinfo
* SUMMARY:  Collect all the information and fill out an RdacInfo
* SCOPE:    local
*
*
* DESCRIPTION:
   
*
* RESTRICTIONS:
*
* RETURNS:
*   TRUE or FALSE.  TRUE completed successfully.
*************************************************************************/
 
LWORD 
mpp_BuildRdacinfo(MPP_HANDLE DeviceVertex, ControllerAddress_t *DeviceAddress, LWORD Lun)
{
	RdacDeviceInformation_t *RdacInfo;
	BYTE ControllerIndex, PathIndex;
	BYTE ArrayWWN[16], ArrayAsciiName[31], ExtLun;
	LINT LockLevel;
	BYTE FirmwareVersion[3];
   	LWORD IsUnconfiguredLun = MPPCMN_UNCONFIGURED_LUN_NOTCHECKED;
	
	bzero(ArrayWWN, sizeof(ArrayWWN));
	bzero(ArrayAsciiName, sizeof(ArrayAsciiName));

    	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_BuildRdacinfo: called with vertex 0x%x, ControllerAddress 0x%lx, Lun %d\n",
	DeviceVertex, DeviceAddress, Lun));
	if( Lun >= mpp_MaxLunsPerArray ) {
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 61, "Lun number(%d) exceeds Max Configured Value (%d)\n",
			Lun, mpp_MaxLunsPerArray));
		return(MPPCMN_CONFIG_PARAMETER_OUT_OF_LIMIT);
	}

	if(mppSys_DeviceAlreadyDiscovered(DeviceVertex, Lun) ) {
		MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_BuildRdacinfo: mppSys_DeviceAlreadyDiscovered: Device already present in RdacInfo \n"));
		return(TRUE);
		
	}

	RdacInfo = mpp_MatchExistingControllerPath(DeviceAddress, &ControllerIndex, &PathIndex);
	MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_BuildRdacinfo: mpp_MatchExistingControllerPath returned RdacInfo 0x%lx\n",
	RdacInfo));

	if( !RdacInfo ) {

		if( !mpp_IsArray(DeviceVertex,  &FirmwareVersion[0]) ) {
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 62, "Device 0x%08x is not an array\n",
			DeviceVertex));
			return(FALSE);
		}

      if( (IsUnconfiguredLun == MPPCMN_UNCONFIGURED_LUN_NOTCHECKED) &&
         (!mppCmn_IsConfiguredDevice(DeviceVertex,DeviceAddress,Lun)) )
      {
         MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3,
            "Device 0x%08x, Lun %d is not configured\n",DeviceVertex,Lun));
         IsUnconfiguredLun = MPPCMN_UNCONFIGURED_LUN;
         return(MPPCMN_UNCONFIGURED_LUN);
      }
      else
      {
         IsUnconfiguredLun = FALSE;
      }

		if( !mpp_GetArrayName(DeviceVertex, &ArrayWWN[0], &ArrayAsciiName[0], &ExtLun) ) {
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 63, "mpp_GetArrayName returned an error on Device 0x%08x\n",
			DeviceVertex));
			return(FALSE);
		}

		if( !mpp_ControllerSlot(DeviceVertex, &ControllerIndex) ) {
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 64, "mpp_ControllerSlot returned an error on %s\n",
			&ArrayAsciiName[0]));
			return(FALSE);
		}

		RdacInfo = mpp_MatchExistingController(&ArrayWWN[0], ControllerIndex, &PathIndex);

		if( RdacInfo && (PathIndex == 0xff) ) {
			/* max path configured limit reached */
			return(MPPCMN_CONFIG_PARAMETER_OUT_OF_LIMIT);
		}
		MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_BuildRdacinfo: mpp_MatchExistingController returned RdacInfo 0x%lx\n",
			RdacInfo));

		if( !RdacInfo ) {

			if( mpp_MaxArrayModuleOverflow(&ArrayWWN[0], &ArrayAsciiName[0]) == TRUE ) {
				MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 120, "Identified Array Module exceeds Max Configured Value (%d)\n",
						mpp_MaxArrayModules));
				return(MPPCMN_CONFIG_PARAMETER_OUT_OF_LIMIT);
			}
			
				
			if( !(RdacInfo = mpp_AllocRdacinfo(DeviceVertex, &ArrayWWN[0], &ArrayAsciiName[0])) ) {
				MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 66, "mpp_AllocRdacinfo returned an error\n"));
				return(FALSE);
			}
			
			MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_BuildRdacinfo: mpp_AllocRdacinfo returned RdacInfo 0x%lx\n",
			RdacInfo));
			
			PathIndex = 0;
			MPP_LOCK(RdacInfo->Lock, LockLevel);

	       	} else {
			MPP_LOCK(RdacInfo->Lock, LockLevel);
		}

		bcopy( FirmwareVersion, &RdacInfo->FirmwareVersion, 3);
		if(((RdacInfo->FirmwareVersion[0] & 0x0f) == 0x05) && ((RdacInfo->FirmwareVersion[1] & 0x0f0 ) >= 0x40))
			RdacInfo->FWSonoran4OrLater = TRUE;
		if((RdacInfo->FirmwareVersion[0] & 0x0f) > 0x05) 
			RdacInfo->FWSonoran4OrLater = TRUE;

	       	if( !PathIndex ) {
			MPP_UNLOCK(RdacInfo->Lock, LockLevel);
			mpp_InsertController(DeviceVertex, RdacInfo, ControllerIndex);
			MPP_LOCK(RdacInfo->Lock, LockLevel);
		}
		MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_BuildRdacinfo: calling mpp_InsertControllerPath, Controller %d, Path %d\n",
				ControllerIndex, PathIndex));
						
	       if( !mpp_InsertControllerPath(RdacInfo, ControllerIndex, PathIndex, DeviceAddress) ) {
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 67, "mpp_InsertControllerPath returned an error for %s:%d:%d\n",
			RdacInfo->ModuleName, ControllerIndex, PathIndex));
			MPP_UNLOCK(RdacInfo->Lock, LockLevel);
	       		return(FALSE);
		}
	       	
	} else {
		MPP_LOCK(RdacInfo->Lock, LockLevel);
	}

	if( !RdacInfo->RdacLuns[Lun].Present ) {
		MPP_UNLOCK(RdacInfo->Lock, LockLevel);

      if((IsUnconfiguredLun == MPPCMN_UNCONFIGURED_LUN_NOTCHECKED) &&
         (!mppCmn_IsConfiguredDevice(DeviceVertex,DeviceAddress,Lun)))
      {
         MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3,
            "Device 0x%08x, Lun %d is not configured\n",DeviceVertex,Lun));
         IsUnconfiguredLun = MPPCMN_UNCONFIGURED_LUN_NOTCHECKED;
			return(MPPCMN_UNCONFIGURED_LUN);
      }
      else
      {
         IsUnconfiguredLun = FALSE;
      }

		if( !mpp_InsertLun(DeviceVertex, RdacInfo, ControllerIndex, (BYTE) Lun) )  {
			MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 68, "mpp_InsertLun returned an error for %s:%d:%d:%d\n",
			RdacInfo->ModuleName, ControllerIndex, PathIndex, Lun));
			return(FALSE);
		}
		MPP_LOCK(RdacInfo->Lock, LockLevel);
	}
	MPP_UNLOCK(RdacInfo->Lock, LockLevel);

   
   if((IsUnconfiguredLun == MPPCMN_UNCONFIGURED_LUN_NOTCHECKED) &&
         (!mppCmn_IsConfiguredDevice(DeviceVertex,DeviceAddress,Lun)))
   {
      MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3,
         "Device 0x%08x, Lun %d is not configured\n",DeviceVertex,Lun));
      IsUnconfiguredLun = MPPCMN_UNCONFIGURED_LUN_NOTCHECKED;
		return(MPPCMN_UNCONFIGURED_LUN);
   }
   else
   {
      IsUnconfiguredLun = FALSE;
   }
   

	if( !RdacInfo->RdacLuns[Lun].LunControllers[ControllerIndex]->LunPaths[PathIndex].LunPathDevice &&
	    !mpp_InsertLunPath(DeviceVertex, RdacInfo, ControllerIndex, PathIndex, (BYTE) Lun) ) {
		MPP_ERRORLOGPRINT((MPP_ERR_FATAL, 69, "mpp_InsertLunPath returned an error for %s:%d:%d:%d\n",
			RdacInfo->ModuleName, ControllerIndex, PathIndex, Lun));
		return(FALSE);
	}

	MPP_LOCK(RdacInfo->Lock, LockLevel);
	RdacInfo->RdacLuns[Lun].PseudoRemoveEligible = FALSE;
	
	MPP_UNLOCK(RdacInfo->Lock, LockLevel);
	return(TRUE);
}

/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_RemoveLun
* SUMMARY:  Remove a physical Lun from an RdacInfo
* RETURNS:
*   TRUE or FALSE.  TRUE completed successfully.
*************************************************************************/
 
LWORD 
mpp_RemoveLun(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, BYTE Lun)
{
	LINT LockLevel;
	LWORD i, PathExists, VirtualLunExists;
	ArrayModuleEntry_t *ModPtr;

	MPP_DEBUGPRINT((MPP_DETACH_DEBUG+MPP_DEBUG_LEVEL_3, "mpp_RemoveLun: %s:%d:%d:%d\n",
		RdacInfo->ModuleName, Controller, Path, Lun));
	
	MPP_LOCK(RdacInfo->Lock, LockLevel);

	if( RdacInfo->RdacLuns[Lun].UTMLun ) {
		mpp_RemoveUTM(DeviceVertex, RdacInfo, Controller, Path, Lun);
		MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 70, "UTM LUN %s:%d:%d:%d has been removed\n",
			RdacInfo->ModuleName, Controller, Path, Lun));
	}
	
	if( RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[Path].LunPathDevice ) {	 	  
		mpp_RemoveLunLink(RdacInfo, Controller, Path, Lun);
		MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 71, "Physical path %s:%d:%d:%d has been removed\n",
			RdacInfo->ModuleName, Controller, Path, Lun));
			
		bzero( &RdacInfo->RdacLuns[Lun].LunControllers[Controller]->LunPaths[Path], sizeof(LunPathInfo_t));
		if( !(--RdacInfo->RdacLuns[Lun].LunControllers[Controller]->NumberOfLunObjects) ) {
			MPP_DEBUGPRINT((MPP_DETACH_DEBUG+MPP_DEBUG_LEVEL_1, "mpp_RemoveLun: All Lun Paths removed for %s:%d:%d\n",
			RdacInfo->ModuleName, Controller, Lun));
			if( !RdacInfo->RdacLuns[Lun].LunControllers[Controller^1]->NumberOfLunObjects ) {
				MPP_DEBUGPRINT((MPP_DETACH_DEBUG+MPP_DEBUG_LEVEL_1, "mpp_RemoveLun: All Lun Paths removed for %s:%d\n",
				RdacInfo->ModuleName, Lun));
				RdacInfo->RdacLuns[Lun].PseudoRemoveEligible = TRUE;
			}
		}
	}

	PathExists = 0;
	for(i=0; i<mpp_MaxLunsPerArray; ++i) {
		if( RdacInfo->RdacLuns[i].LunControllers[Controller]->LunPaths[Path].LunPathDevice ) {
			PathExists = 1;
			break;
		}
	}	
	if( !PathExists && RdacInfo->ControllerInfo[Controller]->ControllerPath[Path].Present ) {
		MPP_DEBUGPRINT((MPP_DETACH_DEBUG+MPP_DEBUG_LEVEL_1,
			"mpp_RemoveLun: All LUNs on Path %s:%d:%d have been removed\n",
			RdacInfo->ModuleName, Controller, Path));
		mpp_RemovePathDirectory(DeviceVertex, RdacInfo, Controller, Path);

		bzero(&RdacInfo->ControllerInfo[Controller]->ControllerPath[Path], sizeof(RdacControllerPath_t));
		
		--RdacInfo->ControllerInfo[Controller]->NumberOfPaths;
		MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 72, "Physical path %s:%d:%d has been removed\n",
		RdacInfo->ModuleName, Controller, Path));
	}
		
	if( RdacInfo->ControllerInfo[Controller]->ControllerPresent && !RdacInfo->ControllerInfo[Controller]->NumberOfPaths ) {
		MPP_DEBUGPRINT((MPP_DETACH_DEBUG+MPP_DEBUG_LEVEL_3,
			"mpp_RemoveLun: Controller %s:%d has been removed\n",
			RdacInfo->ModuleName, Controller));
		mpp_RemoveControllerDirectory(DeviceVertex, RdacInfo, Controller);

		bzero(RdacInfo->ControllerInfo[Controller], sizeof(RdacControllerInformation_t)-sizeof(RdacControllerPath_t));

		RdacInfo->SingleController = TRUE;
		MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 73, "Controller %s:%d has been removed\n",
			RdacInfo->ModuleName, Controller));
	}

	if( RdacInfo->RdacLuns[Lun].PseudoRemoveEligible && !RdacInfo->RdacLuns[Lun].PseudoAddLock ) {
		if( !RdacInfo->RdacLuns[Lun].UTMLun ) {
			mpp_RemoveVirtualLun(RdacInfo, Lun);
			MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 74, "Virtual Lun %s:%d has been removed\n",
				RdacInfo->ModuleName, Lun));
		}

		if(mpp_IsOkayToClearRdacLuns(RdacInfo, Lun))
		{
			bzero(&RdacInfo->RdacLuns[Lun],
				(sizeof(RdacLunInformation_t)-((2*sizeof(LunPathObjects_t *)) + 16)) );
		}
	}

	VirtualLunExists = 0;
	for(i=0; i<mpp_MaxLunsPerArray; ++i) {
		if( RdacInfo->RdacLuns[i].Present || RdacInfo->RdacLuns[i].PseudoLunObject )
			VirtualLunExists = 1;
	}

	if( !VirtualLunExists &&
	    !RdacInfo->ControllerInfo[0]->ControllerPresent &&
	    !RdacInfo->ControllerInfo[1]->ControllerPresent )
	{
		mpp_RemoveModule(DeviceVertex, RdacInfo);
		ModPtr = mpp_ModuleArray;
		ModPtr += RdacInfo->VirtualTargetId;
		ModPtr->RdacInfo = NULL;
		MPP_ERRORLOGPRINT((MPP_ERR_RECOVERED, 75, "Array %s has been removed\n",
		RdacInfo->ModuleName));
		MPP_UNLOCK(RdacInfo->Lock, LockLevel);
		MPP_LOCK_RELEASE(&RdacInfo->Lock);
		MPP_FREE(RdacInfo, MPP_RDACINFOSIZE(mpp_MaxLunsPerArray, mpp_MaxPathsPerController));
	} else {
		MPP_UNLOCK(RdacInfo->Lock, LockLevel);
	}
	return(0);
}


/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_ChkIOForWandV
* SUMMARY:  Check the cdb passed in and set the 2 boolean output parameters based on what is found in the 
*			cdb and sense data passed in.
*
* INPUT:	cdb - 12 byte cdb of the completed op
*			SenseDataPresent - TRUE if sense data present in the completed op, FALSE otherwise
*			SenseKey - sense data of completed op, null if no data
*			ASC - the ASC code of the completed op, null if no data
*			ASCQ - the ASCQ code of the completed op, null if no data
*			b_WandV - boolean * output parameter
*			b_RetryWithWrite - boolean * output parameter
*
* OUTPUT VARS:		b_WandV - set to true if the CDB passed in is a write-with-verify and the parity-check bit is on.
*					b_RetryWithWrite - set to true if either a RAID 5 or RAID 1 write error is detected.
*
* RETURNS:  void
*					
*************************************************************************/
void
mpp_ChkIOForWandV(BYTE *cdb, BOOL SenseDataPresent, BYTE SenseKey, BYTE ASC, 
				  BYTE ASCQ, BOOL *b_WandV, BOOL *b_RetryWithWrite)
{
	
	*b_WandV = FALSE;
	*b_RetryWithWrite = FALSE;
	
	if (*cdb != SCSI_WRITE_VERIFY)
	{
		return;
	}
	
	// see if ParChk bit is turned on
	if (cdb[1] & 0x08)
	{
		*b_WandV = TRUE;
	}
	
	if (*b_WandV && SenseDataPresent)
	{
		// chk for RAID 5 error
		if (SenseKey == SENSE_KEY_HARDWARE_ERROR && 
			ASC == 0x84 && 
			ASCQ == 0x00)
		{
			MPP_DEBUGPRINT((MPP_FAILOVER_IO_DEBUG+MPP_DEBUG_LEVEL_2, 
				"mpp_ChkIOForWandV: RAID 5 WriteAndVerify IO failed\n"));
			*b_RetryWithWrite = TRUE;
		}
		// chk for RAID 1 error
		else if (SenseKey == SENSE_KEY_ILLEGAL_REQUEST && 
			ASC == 0x24 && 
			ASCQ == 0x00)
		{
			MPP_DEBUGPRINT((MPP_FAILOVER_IO_DEBUG+MPP_DEBUG_LEVEL_2, 
				"mpp_ChkIOForWandV: RAID 1 WriteAndVerify IO failed\n"));
			*b_RetryWithWrite = TRUE;
		}
	}
	
	return;
}


/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_SetWandVBit
* SUMMARY:  Sets the error-recovery bit for an op. This bit is set to indicate that the next retry of this op
*			should be performed with a write-and-verify. The data must be stored as state information with the
*			original op so it can be retrieved and tested before the op is issued by the IOStart routine.
*
* INPUT:	ErrorRecovery - boolean * parameter that will be set.
*			b_WandV - input parameter, set in mpp_ChkIOForWandV
*			b_RetryWithWrite - input parameter, set in mpp_ChkIOForWandV
*
* RETURNS:  void
*					
*************************************************************************/
void
mpp_SetWandVBit(BOOL *ErrorRecovery, BOOL b_WandV, BOOL b_RetryWithWrite)
{
	if (b_WandV && !b_RetryWithWrite)
	{
		*ErrorRecovery = 1;
	}
}


/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_TestBuildWandVOp
* SUMMARY:  Logic to determine based on the op status whether the next retry of this op needs
*			to be a write w/ verify.
*
* INPUT:	cdb - 12 byte cdb of the completed op
*			ErrorRecovery - boolean flag that indicates that the next retry of op should be with a W & V
*			b_WandV - boolean set in function mpp_ChkIOForWandV
*			b_RetryWithWrite - boolean set in function mpp_ChkIOForWandV
*			oldController - the controller that the IO WAS previously issued on
*			newController - the controller that the IO WILL BE issued on
*
* RETURNS:	TRUE - a write-with-verify is warranted
*			FALSE - a write-with-verify should not be used
*************************************************************************/
int
mpp_TestBuildWandVOp(BYTE *cdb, BOOL ErrorRecovery, BOOL b_WandV, BOOL b_RetryWithWrite, 
					 int oldController, int newController)
{
	
	if (!b_RetryWithWrite && (
		(ErrorRecovery == 1) ||
		(((*cdb == SCSI_WRITE || *cdb == SCSI_SMALL_WRITE) || 
		((*cdb == SCSI_WRITE_VERIFY) && ! b_WandV)) &&
		oldController != newController)))
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}


/**************************************************************************
* PROCEDURE
*
* NAME:     mpp_BuildWriteWithVerify
* SUMMARY:  Retool the write op so that it is a Write And Verify operation.
*			We do this because of a hole in controller code that allows an
*			interrupted write on a controller with write through cache turned on to
*			generate parity corruption.  The Write And Verify should
*			fix the problem for retried Write operations.
*
* INPUT:	cdb - 12 byte cdb of the completed op. The op will be modified to use a write-with-verify.
*
* RETURNS:	void
*************************************************************************/
void
mpp_BuildWriteWithVerify(BYTE *cdb)
{
	unsigned char newCdb[12];
	
	
	bzero(newCdb, 12);
	newCdb[0] = 0x2e; // op for Write And Verify
	
	if (*cdb == SCSI_SMALL_WRITE)
	{
		// this is an 0xa, 6 byte write op
		newCdb[1] = (cdb[1] & 0xe0) | 0x08;  // LUN + turn on the ParChk bit
		newCdb[3] = cdb[1] & 0x1f; // MSB top 5 bits
		newCdb[4] = cdb[2]; // MSB
		newCdb[5] = cdb[3]; // LSB
		newCdb[8] = cdb[4]; // transfer len
		newCdb[9] = cdb[5]; // control
	}
	else if (*cdb == SCSI_WRITE)
	{
		// this is an 0x2a, 10 byte write op
		newCdb[1] = (cdb[1] & 0xf0) | 0x08;  // LUN + DPO + turn on the ParChk bit
		bcopy(&cdb[2], &newCdb[2], 8);
	}
	else // its a write and verify
	{
		// just copy verbatim and set the ParChk bit
		bcopy(cdb, newCdb, 12);
		newCdb[1] |= 0x08;
	}

	MPP_DEBUGPRINT((MPP_FAILOVER_IO_DEBUG+MPP_DEBUG_LEVEL_2, 
		"mpp_BuildWriteWithVerify: rebuilt 0x%x write command to WriteAndVerify\n", 
		*cdb));

	// copy the new cdb back to the original op
	bcopy(newCdb, cdb, 12);
	return;
}

/**************************************************************************
* PROCEDURE
*
* NAME:     mppCmn_IsConfiguredDevice()
* SUMMARY:  Verify the given physical device, which is represented by the 
   "MPP_HANDLE DeviceVertex", is a configured device in the storage array. 
   This function issues "Mode Sense" command with Page 2C to the controller and 
   verify whether or not the "Lun" is a configured LUN in the given storage partition.
*
* INPUT: DeviceVertex- A physical device object whose configured-status will be verified
*        DeviceAddress -A ControllerAddress_t object, which represents 
                  the DeviceVertex's physical connections in a platform. It is not used 
                  at the present code.
         Lun - the Lun number of the DeviceVertex.
* RETURNS: TRUE if the DeviceVertex is a configured LUN; Otherwise,  FALSE

*************************************************************************/
BOOL
mppCmn_IsConfiguredDevice(MPP_HANDLE DeviceVertex, ControllerAddress_t *DeviceAddress, LWORD Lun)
{

   BYTE                       *cdb;
   BYTE                       *page2C;
   BYTE                       MaxLuns;
   BOOL                       isPage2CSubPage1 = FALSE;
   LWORD                      PageSize;
   BYTE                       cdblen = 10;
   ModePage2CSubPage_t        *modePage2CSubPage;
   ModePage2C_t               *modePage2C;
   BOOL                       isConfigured;

   MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, 
      "Entering mppCmn_IsConfiguredDevice: vertex 0x%x, ControllerAddress 0x%lx, Lun %d\n",
	    DeviceVertex, DeviceAddress, Lun)); 
 
   if(mpp_GetMaxLunsSupported(DeviceVertex, &MaxLuns))
   {
     
	   // Anything above 31 Luns must use the SubPage for 0x2C
      if(MaxLuns > 0x1f)
      {
		   isPage2CSubPage1 = TRUE;
         page2C = (BYTE *) MPP_INT_KMEM_ALLOC(sizeof(ModePage2CSubPage_t)+10);
         if(!page2C)
         {
            MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 123, "Unable to allocate memory\n"));
            return FALSE;
         }
         PageSize = sizeof(ModePage2CSubPage_t);
         
         cdb = ((BYTE *) page2C) + PageSize;
      }
      else
      {
         isPage2CSubPage1 = FALSE;
         page2C = (BYTE *) MPP_INT_KMEM_ALLOC(sizeof(ModePage2C_t)+10);
         if(!page2C)
         {
            MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 124, "Unable to allocate memory\n"));
            return FALSE;
         }
         PageSize = sizeof(ModePage2C_t);
         cdb = ((BYTE *) page2C) + PageSize;
		}
   }
   else
   {
      MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 125, "Failed to get GetMaxLunsSupported\n")); 
      return FALSE;
   }


   /*
   *preparing the CDB
   */
   *cdb = SCSI_MODE_SENSE;
   *(cdb+1) = 0x08; /*DBD bit on*/
   *(cdb+2) = (BYTE)(0x2c); /*PC = 00b (current) and Page code = 0x2c*/
   if (isPage2CSubPage1)
   {
      *(cdb+3) = 0x01;
   }
   else
   {
      *(cdb+3) = 0x00;
   }

   *(cdb+7) = (BYTE) (PageSize >> 8) &0x00ff;
   *(cdb+8) = (BYTE) PageSize & 0x00ff;
   if(mpp_SynchronousIo(DeviceVertex, cdb,cdblen, page2C,PageSize, 1) != MPP_NO_ERROR)
   {
      /*
      * log error
      */
      MPP_ERRORLOGPRINT((MPP_ERR_RETRYABLE, 126, "Failed to issue mode sense\n"));
      MPP_FREE(page2C, PageSize+10);
      return FALSE;
   }

   if (isPage2CSubPage1)
   {
      modePage2CSubPage = (ModePage2CSubPage_t *)page2C;
      isConfigured = modePage2CSubPage->ControllerLunTable[Lun] & 0x03 ? TRUE:FALSE;
   }
   else
   {
      modePage2C = (ModePage2C_t*)page2C;
      isConfigured = modePage2C->ControllerLunTable[Lun] & 0x03 ? TRUE:FALSE;
   }

   MPP_FREE(page2C, PageSize+10);
   MPP_DEBUGPRINT((MPP_ATTACH_DEBUG+MPP_DEBUG_LEVEL_3, 
      "mppCmn_IsConfiguredDevice: vertex 0x%x, ControllerAddress 0x%lx, Lun %d, isConfigured %d\n",
	    DeviceVertex, DeviceAddress, Lun, isConfigured)); 

   return isConfigured;  
}
