/*******************************************************************************
* Copyright (C) 2003 by LSI Logic Corporation.  
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the
* Free Software Foundation,  version 2 of the License.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
********************************************************************************/
/*******************************************************************************

NAME            MPP_Common.h
SUMMARY         %description%
VERSION         %version: 23 %
UPDATE DATE     %date_modified: Tue Feb 03 10:45:51 2004 %
PROGRAMMER      %created_by:    yqi %

        Copyright 2000 by LSI Logic Inc.

DESCRIPTION:

INCLUDE FILES:

NOTES:

RESTRICTIONS:

SEE ALSO:

REFERENCE:

IMPLEMENTATION:

MODIFICATION HISTORY:

*******************************************************************************/


#ifndef __INCMPP_Common
#define __INCMPP_Common


/***  INCLUDES  ***/  
#include "MPP_Sysdep.h"



/***  CONSTANT DEFINITIONS  ***/
#define TRUE 1
#define FALSE 0

/* MPP debug levels */
#define MPP_DEBUG_LOG_ONLY     0x80000000
#define MPP_DEBUG_MEMORY_ONLY  0x40000000
#define MPP_INIT_DEBUG         0x20000000
#define MPP_ATTACH_DEBUG       0x10000000
#define MPP_IOCTL_DEBUG        0x08000000
#define MPP_OPEN_DEBUG         0x04000000
#define MPP_READ_DEBUG         0x02000000
#define MPP_HBA_COMMAND_DEBUG  0x01000000
#define MPP_ABORT_DEBUG	       0x00800000
#define MPP_DUMP_DEBUG	       0x00400000
#define MPP_SYNC_IO_DEBUG      0x00200000
#define MPP_FAILOVER_IO_DEBUG  0x00100000
#define MPP_FAILOVERSCAN_DEBUG 0x00080000
#define MPP_AVTSCAN_DEBUG      0x00040000
#define MPP_UTM_DEBUG          0x00020000
#define MPP_DETACH_DEBUG       0x00010000
#define MPP_ALLOC_DEBUG        0x00008000
#define MPP_PNP_DEBUG          0x00004000
#define MPP_POWER_DEBUG        0x00002000
#define MPP_RESERVE_DEBUG        0x00001000
#define MPP_RETRY_DEBUG        0x00000800
#define MPP_DEBUG_LEVEL_1 1
#define MPP_DEBUG_LEVEL_2 2
#define MPP_DEBUG_LEVEL_3 4
#define MPP_DEBUG_LEVEL_4 8


#define MPP_DEFAULT_VENDOR_ID "LSI     "
#define MPP_DEFAULT_PRODUCT_ID "VirtualDisk     "
#define MPP_EPOINT "!"
#define MPP_CARET "^"

#define MPP_PREFIX "mpp_"
#define MINIMUM_MAJOR_REL 4
#define MINIMUM_MINOR_REL 1

/* MPP configuration parameters */
#define MPP_DEBUG_LEVEL "DebugLevel"
#define MPP_NOTREADYWAITTIME "NotReadyWaitTime"
#define MPP_BUSYWAITTIME "BusyWaitTime"
#define MPP_QUIESCENCEWAITTIME "QuiescenceWaitTime"
#define MPP_MAXLUNSPERARRAY "MaxLunsPerArray"
#define MPP_MAXPATHSPERCONTROLLER "MaxPathsPerController"
#define	MPP_INQUIRYWAITTIME "InquiryWaitTime"
#define	MPP_INQUIRYINTERVAL "InquiryInterval"
#define MPP_SCANINTERVAL "ScanInterval"
#define MPP_MAXARRAYMODULES "MaxArrayModules"
#define MPP_VIRTUALADAPTERNAME "VirtualAdapterName"
#define MPP_ERRORLEVEL "ErrorLevel"
#define MPP_VENDORID "VirtualDiskVendorId"
#define MPP_PRODUCTID "VirtualDiskProductId"
#define MPP_SELECTIONTIMEOUTRETRYCOUNT "SelectionTimeoutRetryCount"
#define MPP_COMMANDTIMEOUTRETRYCOUNT "CommandTimeoutRetryCount"
#define MPP_UARETRYCOUNT "UaRetryCount"
#define MPP_RETRYCOUNT "RetryCount"
#define MPP_IDFORMAT "ID%d"
#define MPP_SYNCHTIMEOUT "SynchTimeout"
#define MPP_FAILOVERQUIESCETIME "FailOverQuiescenceTime"
#define MPP_BUSNUMBER "BusNumber"
#define MPP_HOLDALTINRESET "HoldAltInReset"
#define	MPP_CONTROLLERIOWAITTIME "ControllerIoWaitTime"
#define	MPP_ARRAYIOWAITTIME "ArrayIoWaitTime"
#define	MPP_DISABLELUNREBALANCE "DisableLUNRebalance"
#define MPP_FAILOVERTIMEOUT "FailoverTimeout"
#define MPP_FAILBACKTOCURRENTALLOWED "FailBackToCurrentAllowed"
#define MPP_DOUARETRY "DoUaRetry"
#define MPP_S2TOS3KEY "S2ToS3Key"
#define DEVNM_LEN               32

/* mpp driver statuses */
#define MPP_GOOD_STATUS	0
#define MPP_CHECK_CONDITION 1
#define MPP_SCSI_BUSY 2
#define MPP_SCSI_RESERVATION 3
#define MPP_UNSUPPORTED_SCSI_STATUS 4
#define MPP_INVALID_REQUEST 5
#define MPP_SELECTION_TIMEOUT 6
#define MPP_HARDWARE_ERROR 7
#define MPP_COMMAND_TIMEOUT 8
#define MPP_COMMAND_ABORTED 9
#define MPP_UNRECOGNIZED_OS_STATUS 10
#define MPP_REQUEST_SENSE_FAILED 11

/* mpp actions on I/O statuses */
#define MPP_NO_ERROR 0
#define MPP_RETURN_ERROR 1
#define MPP_RETRY_DEC_COUNT 2
#define MPP_RETRY_NO_DEC 3
#define MPP_RETRY_ALTERNATE_CONTROLLER 4
#define MPP_FAILOVER 5
#define MPP_FAILOVER_CONTROLLER 6
#define MPP_FAILOVER_TO_CURRENT 7

#define MPP_NO_FAILOVER_ERROR 0
#define MPP_RETRY_FAILOVER 1
#define MPP_RETURN_FAILOVER_ERROR 2

/* mpp driver error levels - display error messages when the mpp_ErrorLevel is equal to or less than the level */
#define MPP_ERR_ALL            0  /* display all errors */
#define MPP_ERR_RECOVERED      1  /* display controller failover + path failover + retryable + fatal + recovered errors */
#define MPP_ERR_RETRYABLE      2  /* display controller failover + path failover + retryable + fatal errors */
#define MPP_ERR_PATH_FAILOVER  3  /* display controller failover + path failover + fatal errors */
#define MPP_ERR_CTLR_FAILOVER  4  /* display controller failover + fatal errors */
#define MPP_ERR_FATAL          5  /* display fatal errors only */


#define MPP_VIRTUAL_BUS_TYPE 1
#define MPP_VIRTUAL_DISK_TYPE 2
#define MPP_UTM_DISK_TYPE 3
#define MPP_PHYSICAL_DISK_TYPE 4

/* MPP Virtual Bus ioctls */
#define MPP_IOCTL_GETPATHS  	0x4D01
#define MPP_IOCTL_GETLUNS  	0x4D02
#define MPP_IOCTL_GETRDACINFO  	0x4D03
#define MPP_IOCTL_FAILBACKSCAN 	0x4D04
#define MPP_IOCTL_AVTCHECKSCAN 	0x4D05
#define MPP_IOCTL_AVTPATHSCAN  	0x4D06
#define MPP_IOCTL_SETDEBUG  	0x4D07
#define MPP_IOCTL_SETERROR  	0x4D08
#define MPP_IOCTL_BUSSCAN  	0x4D09
#define MPP_IOCTL_GETMODULES	0x4D0A

/* Additional MPP status codes */
#define	MPP_PSEUDO_BUS_ENABLED	1
#define	MPP_PSEUDO_BUS_DISABLED 0

/* Thread Delay Resolutions */
#define	MPPCMN_DELAY_SECONDS	  1
#define	MPPCMN_DELAY_MILLISECONDS 1000

/* mpp_BuildRdacinfo() return status
*  TRUE                       - is a configured LUN
*  FALSE                      - not a storage array device
*  MPPCMN_UNCONFIGURED_LUN    - is a storage array device but is not configured
*  MPPCMN_CONFIG_PARAMETER_OUT_OF_LIMIT - configured parameter (in mpp.conf) overflow
*/
#define  MPPCMN_UNCONFIGURED_LUN                 2
#define  MPPCMN_UNCONFIGURED_LUN_NOTCHECKED      3
#define  MPPCMN_CONFIG_PARAMETER_OUT_OF_LIMIT    4	

/* DisableLunRebalance parameter definitions */
#define	MPPCMN_REBALANCE_ALL			0
#define	MPPCMN_REBALANCE_NON_AVT_MODE		1
#define	MPPCMN_REBALANCE_AVT_MODE		2
#define	MPPCMN_REBALANCE_NONE			3

/*
* Data transfer directions
*/

#define MPPCMN_XFER_HOST_DEV              0   /*data transfer from initiator to target */
#define MPPCMN_XFER_DEV_HOST              1   /*data transfer from target to initiator */
#define MPPCMN_XFER_NONE                  2   /*no data transfer */
#define MPPCMN_XFER_UNKNOWN               3   /*data transfer direction is unknown */

#ifdef MPP_DEBUG
#define MPP_DEBUGPRINT(x)   mpp_DebugPrint x 
#else
#define MPP_DEBUGPRINT(x) 
#endif
#define MPP_ERRORLOGPRINT(x)   mpp_ErrorLog x 

#define MPP_RDACINFOSIZE(LUNS, PATHS)	(LWORD) (sizeof(RdacDeviceInformation_t) + \
					(sizeof(RdacLunInformation_t) * (LUNS-1)) + \
					(2*(sizeof(RdacControllerInformation_t))) + \
       					(2*(sizeof(RdacControllerPath_t)*(PATHS-1)) ) + \
       					LUNS * ((2*(sizeof(LunPathObjects_t))) + \
       					(2*(sizeof(LunPathInfo_t)* (PATHS-1)))) )

/***  TYPE DEFINITIONS  ***/
typedef TEXT          DevName_t[ DEVNM_LEN ];
typedef struct getRdacInfoIoctl {
	LWORD 	target;
	LWORD   BufferSize;
	void	*RdacInfoAdrs;
	void	*RdacName;
} getRdacInfoIoctl_t;

typedef enum _MPP_DEVICE_STATE {
	NotStarted = 0,
	Started,
	StopPending,
	Stopped,
	RemovePending,
	SurpriseRemovePending,
	Deleted,
	Queued,
	UnKnown
} MPP_DEVICE_STATE;

typedef enum _MPP_FEATURE_ID {
	FeatUnknown = 0,
	FeatMinimumFirmwareRelease,
	FeatPage2CSubPage
} MPP_FEATURE_ID;

typedef struct	_MPP_FEATURE_SUPPORT {
	MPP_FEATURE_ID		FeatureId;
	BYTE			MajorRelease;
	BYTE			MinorRelease;
	BYTE			RevisionRelease;
} MPP_FEATURE_SUPPORT, *PMPP_FEATURE_SUPPORT;


/***  GLOBALS  ***/ 
extern TEXT mpp_VendorId[9];
extern TEXT mpp_ProductId[17];
extern TEXT mpp_Version[12];

extern LWORD mpp_Debug;
extern LWORD mpp_NotReadyWaitTime;
extern LWORD mpp_BusyWaitTime;
extern LWORD mpp_QuiescenceWaitTime;
extern LWORD mpp_InquiryWaitTime;
extern LWORD mpp_MaxLunsPerArray;
extern LWORD mpp_MaxPathsPerController;
extern LWORD mpp_ScanInterval;
extern LWORD mpp_InquiryInterval;
extern LWORD mpp_MaxArrayModules;
extern LWORD mpp_ErrorLevel;
extern LWORD mpp_SelectionTimeoutRetryCount;
extern LWORD mpp_CommandTimeoutRetryCount;
extern LWORD mpp_UaRetryCount;
extern LWORD mpp_SyncRetryCount;
extern LWORD mpp_SynchTimeout;
extern LWORD mpp_FailoverTimeout;
extern LWORD mpp_FailOverQuiescenceTime;
extern LWORD mpp_FailBackToCurrentAllowed;
extern LWORD mpp_DoUARetry;
extern LWORD mpp_HoldAltInReset;
extern LWORD mpp_Page2CSubPage;
extern LWORD mpp_ControllerIoWaitTime;
extern LWORD mpp_ArrayIoWaitTime;
extern LWORD mpp_DisableLUNRebalance;
/* variable used for Scsi2 to Scsi3 persistent reservation */
extern BYTE  mpp_S2ToS3Key[8];
/*** prototypes ***/



#endif        /* End of __INCMPP_Common.h */
