/*******************************************************************************
* Copyright (C) 2003 by LSI Logic Corporation.  
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the
* Free Software Foundation,  version 2 of the License.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
********************************************************************************/
/*******************************************************************************

NAME            MPP_ProtoTypes.h
SUMMARY         %description%
VERSION         %version: 20luns255 %
UPDATE DATE     %date_modified: Thu Nov 20 10:25:23 2003 %
PROGRAMMER      %created_by:    rstankey %

        Copyright 2000 by LSI Logic Inc.

DESCRIPTION:

INCLUDE FILES:

NOTES:

RESTRICTIONS:

SEE ALSO:

REFERENCE:

IMPLEMENTATION:

MODIFICATION HISTORY:

*******************************************************************************/


#ifndef __INCMPP_ProtoTypes
#define __INCMPP_ProtoTypes


/***  ProtoTypes  ***/ 
extern void mpp_DebugPrint(LWORD DebugPrintLevel, TINY *DebugMessage, ...);
extern void mpp_ErrorLog(LWORD Level, LWORD Number, TINY *LogMessage, ...);

extern void mpp_VirtualdiskInquiryData(TEXT *inqData);

extern LWORD mpp_SysdepSynchronousIo(MPP_HANDLE DeviceVertex, BYTE *cdb, BYTE cdblen, void *BufferAddress, LWORD BufferLength, 
                                void *SenseBuffer, LWORD SenseLength, TINY DataDirection, LWORD *SenseLengthReturned,
				LWORD *DataLengthXfered);

extern LWORD mpp_IsArray(MPP_HANDLE DeviceVertex, BYTE *FirmwareVersion);

extern LWORD mpp_BuildRdacinfo(MPP_HANDLE DeviceVertex, ControllerAddress_t *DeviceAddress, LWORD Lun);

extern void mpp_probeVirtualBus(void);

extern MPP_DIR_HANDLE mpp_makeVirtualTarget(targ_t targ);

extern MPP_DIR_HANDLE mpp_CreateControllerVertex(RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex, 
				BYTE Path, ControllerAddress_t *DeviceAddress);

extern MPP_HANDLE mpp_makeVirtualLun(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE Lun, LWORD *PBusStatus);
extern LWORD mpp_IsOkayToClearRdacLuns(RdacDeviceInformation_t *RdacInfo, BYTE Lun);
extern LWORD mppSys_AreControllerPathsFailed(RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex, BYTE Lun);

extern MPP_HANDLE mpp_CreateUtmDevice(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex, 
				BYTE Path, BYTE Lun);
extern LWORD mpp_GetArrayName(MPP_HANDLE DeviceVertex, BYTE *ArrayWWN, BYTE *ArrayAsciiName, BYTE *Lun);
extern void mpp_CreateLunLink(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex, BYTE PathIndex, BYTE Lun); 
extern LWORD mpp_DetermineNodeType(dev_t Node, RdacDeviceInformation_t **RdacInfo, BYTE *ControllerIndex, BYTE *PathIndex,
	 BYTE *Lun); 
extern LWORD mpp_PhysicalDiskOpen(MPP_HANDLE Node, RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex, BYTE PathIndex, BYTE Lun);
extern LWORD mpp_UtmDiskOpen(dev_t Node, RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex, BYTE PathIndex, BYTE Lun);
extern void mpp_UtmDiskClose(dev_t Node, RdacDeviceInformation_t *RdacInfo, BYTE ControllerIndex, BYTE PathIndex, BYTE Lun);
extern LWORD mpp_NativeBusIoctlCmd(dev_t Node, int cmd, void *arg, int mode);
extern MPP_HANDLE mpp_SelectPath(RdacDeviceInformation_t *RdacInfo, BYTE Lun, BYTE *Controller, BYTE *Path);
extern LWORD mpp_AnalyseIoError(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, BYTE Lun, LWORD mpp_status, 
			SenseData_t *SenseData, SINT SenseLength, LWORD DataLengthXfered, MPP_TIME StartTime,
			BYTE *SelectionTimeoutRetryCount, BYTE *CommandTimeoutRetryCount, BYTE *UaRetryCount, BYTE *RetryCount,
			MPP_TIME ControllerIoWaitTime, MPP_TIME ArrayIoWaitTime);
extern LWORD mpp_AnalyseSyncError(LWORD mppStatus, SenseData_t *SenseData, LWORD SenseLengthReturned, 
			LWORD DataLengthXfered, MPP_TIME StartTime, LWORD *SelectionTimeoutRetryCount, 
			LWORD *CommandTimeoutRetryCount, LWORD *UaRetryCount);
extern BYTE mpp_FailPath(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path);
extern MPP_HANDLE mpp_SelectFailoverPath(RdacDeviceInformation_t *RdacInfo, BYTE Lun, BYTE *Controller, BYTE *Path);
extern LWORD mpp_AnalyseFailoverError(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, BYTE Lun, LWORD mpp_status, 
			SenseData_t *SenseData, SINT SenseLength, LWORD DataLengthXfered, MPP_TIME StartTime);
extern void mpp_FailBackScan(void);
extern void mpp_CheckAVTState(void);
extern void mpp_CheckPreferredAVTOwner(BOOL checkAVTEnabled);
extern void mpp_ScanForAddedDevices(void);
extern LWORD mpp_SynchronousIo(MPP_HANDLE DeviceVertex, BYTE *cdb, BYTE cdblen, void *BufferAddress, LWORD BufferLength, TINY Direction);
extern LWORD mpp_RemoveLun(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, BYTE Lun);
extern LWORD mpp_IsSupported(MPP_FEATURE_ID Feature, BYTE *SwVersion);
extern LWORD mpp_NativePseudoDiskIoctlCmd(dev_t Node, int cmd, void *arg, int mode, cred_t *crp, int *rvalp);
extern void mpp_RemoveUTM(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, BYTE Lun);
extern void mpp_RemoveLunLink(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, BYTE Lun);
extern void mpp_RemovePathDirectory(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path);
extern void mpp_ThreadDelay(ULONG DelayTime, ULONG DelayResolution);
extern void mpp_RemoveControllerDirectory(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo, BYTE Controller);
extern void mpp_RemoveVirtualLun(RdacDeviceInformation_t *RdacInfo, BYTE Lun);
extern LWORD mpp_CheckPathGood(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, LWORD Lun);
extern int mpp_OpenVirtualDisk(RdacDeviceInformation_t *RdacInfo, BYTE Lun);
extern int mpp_CloseVirtualDisk(RdacDeviceInformation_t *RdacInfo, BYTE Lun);
extern void mpp_IssueFailover(RdacDeviceInformation_t *RdacInfo, BYTE Controller, BYTE Path, 
	MPP_HANDLE FailoverHandle, BYTE *Page2C, BYTE *cdb);
extern void mpp_RemoveModule(MPP_HANDLE DeviceVertex, RdacDeviceInformation_t *RdacInfo);
extern LINT mpp_open(dev_t *devp, int oflag, int otyp, cred_t *credp);
extern int mpp_ioctl(dev_t dev, int cmd, void *arg, int mode, cred_t *crp, int *rvalp);
extern int mpp_close(dev_t dev, int oflag, int otyp, cred_t *credp);
extern int mpp_read(dev_t dev, uio_t *uiop, cred_t *credp);
extern int mpp_write(dev_t dev, uio_t *uiop, cred_t *credp);
extern void mpp_ChkIOForWandV(BYTE *cdb, BOOL SenseDataPresent, BYTE SenseKey, BYTE ASC, 
				  BYTE ASCQ, BOOL *b_WandV, BOOL *b_RetryWithWrite);
extern void mpp_SetWandVBit(BOOL *ErrorRecovery, BOOL b_WandV, BOOL b_RetryWithWrite);
extern int mpp_TestBuildWandVOp(BYTE *cdb, BOOL ErrorRecovery, BOOL b_WandV, 
								BOOL b_RetryWithWrite, int oldController, int newController);
extern void mpp_BuildWriteWithVerify(BYTE *cdb);
extern LWORD mppSys_DeviceAlreadyDiscovered (MPP_HANDLE Devicepnt, LWORD Lun);


#endif        /* End of __INCMPP_ProtoTypes */
