/*******************************************************************************
* Copyright (C) 2003 by LSI Logic Corporation.  
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the
* Free Software Foundation,  version 2 of the License.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
********************************************************************************/
/*******************************************************************************

NAME            mppUtil_Common.h
SUMMARY         %description%
VERSION         %version: 15 %
UPDATE DATE     %date_modified: Wed Jan 07 14:05:01 2004 %
PROGRAMMER      %created_by:    shankara %

        Copyright 2001 by LSI Logic Inc.

DESCRIPTION:

INCLUDE FILES:

NOTES:

RESTRICTIONS:

SEE ALSO:

REFERENCE:

IMPLEMENTATION:

MODIFICATION HISTORY:

*******************************************************************************/
#ifndef __SRCmppUtil_Common
#define __SRCmppUtil_Common

#include "mppUtil_Sysdep.h"

/***  CONSTANT DEFINITIONS  ***/
#define		TRUE			1
#define		FALSE			0
#define		INVALID			-1
#define		SCAN_FAILBACK		"failback"
#define		SCAN_AVT		"avt"
#define		SCAN_PREFERRED		"preferred"
#define		SCAN_BUSSCAN		"busscan"
#define		NOT_APPLICABLE		"N/A"
#define		INVALID_OPT		-1
#define		MAX_BUSES		255
#define		BUS_PATH_LEN		255
#undef          DEBUG_BUFFER_LENGTH
#define		DEBUG_BUFFER_LENGTH	255
#define		TIME_BUFFER_LENGTH	19
#define		WWN_LENGTH		16
#define		STR_LENGTH		19 /* 18 is the length of each line of the mppUtil GetRequest (-g option) output + 1 byte for \0 */ 
#define		MPPCMN_UTIL_USAGE	"[-d debug_level] [-e error_level] [-g target_id] [-s \"failback\" | \"avt\" | \"preferred\" | \"busscan\"]"
#define		MPPCMN_UTIL_CMDLINE_ARGS	"htmld:e:g:s:o:"
#define		MAX_CMDLINE_LENGTH	80


/***  MACRO DEFINITIONS  ***/
#define		YES_NO(a)		a == 1 ? 'Y' : 'N'
#define		A_OR_B(a)		a == 0 ? 'A' : 'B'

/***  PROCEDURE DEFINITIONS ***/
	VOID	utilDebug(TINY *debugMessage, ...);
	VOID	utilUsage(MPP_STRING prog);
	BOOL	utilDetermineBusFd();
	VOID	utilFormatVertex(MPP_HANDLE vertex, MPP_STRING buffer);
	VOID	utilFormatHandle(MPP_DIR_HANDLE handle, MPP_STRING buffer);
	int	utilFormatLunPathDevice(MPP_HANDLE handle);
	MPP_STRING utilFormatDevState(MPP_DEVICE_STATE state);
	void 	utilFormatControllerAddress(ControllerAddress_t address, MPP_STRING buffer);
	BOOL	mppSys_ProcessCmdLineArgs(LINT option, MPP_STRING argument);

#endif
